clear all
set mem 1g
use "/home/beauchaa/AddHealth/UsableData/w1inschool.dta"

*Convert Gender to Binary*/
drop if s2 != 2 & s2 != 1
gen boys = 0
replace boys = 1 if s2 == 1
gen girls = 0
replace girls = 1 if s2 == 2 

*Convert Hispanic to Binary*/
gen hisp = 0
replace hisp = 1 if s4 == 1
gen other = 0
replace other = 1 if s6a != 1 & s6b != 1 & hisp != 1 & s6c != 1

*Binary Grade Variables*/
gen Grade8 = 1 if s3 == 8
replace Grade8 = 0 if s3 != 8
gen Grade9 = 1 if s3 == 9
replace Grade9 = 0 if s3 != 9
gen Grade10 = 1 if s3 == 10
replace Grade10 = 0 if s3 != 10
gen Grade11 = 1 if s3 == 11
replace Grade11 = 0 if s3 != 11
gen Grade12 = 1 if s3 == 12
replace Grade12 = 0 if s3 != 12

*Generate high shcool size */
gen boy12 = boys*s3/12 if s3 == 12
replace boy12 = 0 if s3 != 12
gen boy11 = boys*s3/11 if s3 == 11
replace boy11 = 0 if s3 != 11
gen boy10 = boys*s3/10 if s3 == 10
replace boy10 = 0 if s3 != 10
gen boy9 = boys*s3/9 if s3 == 9
replace boy9 = 0 if s3 != 9
gen boy8 = boys*s3/8 if s3 == 8
replace boy8 = 0 if s3 != 8
gen boy7 = boys*s3/7 if s3 == 7
replace boy7 = 0 if s3 != 7
gen boy6 = boys*s3/6 if s3 == 6
replace boy6 = 0 if s3 != 6

gen girl12 = girls*s3/12 if s3 == 12
replace girl12 = 0 if s3 != 12
gen girl11 = girls*s3/11 if s3 == 11
replace girl11 = 0 if s3 != 11
gen girl10 = girls*s3/10 if s3 == 10
replace girl10 = 0 if s3 != 10
gen girl9 = girls*s3/9 if s3 == 9
replace girl9 = 0 if s3 != 9
gen girl8 = girls*s3/8 if s3 == 8
replace girl8 = 0 if s3 != 8
gen girl7 = girls*s3/7 if s3 == 7
replace girl7 = 0 if s3 != 7
gen girl6 = girls*s3/6 if s3 == 6
replace girl6 = 0 if s3 != 6

gen gpa_full = (s10a+s10b+s10c+s10d)/4 if s10a <5 & s10b<5 & s10c<5 & s10d<5

gen gpa_low = (gpa_full<2) if gpa_full<.
gen gpa_med = (gpa_full<3&gpa_full>2) if gpa_full<.
gen gpa_hi = (gpa_full>=3) if gpa_full<.

egen f_gpa_low = sum(gpa_low==1&girls==1), by(sschlcde)
egen f_gpa_med = sum(gpa_med==1&girls==1), by(sschlcde)
egen f_gpa_hi = sum(gpa_hi==1&girls==1), by(sschlcde)

egen m_gpa_low = sum(gpa_low==1&girls==0), by(sschlcde)
egen m_gpa_med = sum(gpa_med==1&girls==0), by(sschlcde)
egen m_gpa_hi = sum(gpa_hi==1&girls==0), by(sschlcde)

gen gpa_full_ME = (s10a+s10b)/2 if s10a <5 & s10b<5 

gen gpa_low_ME = (gpa_full_ME<2) if gpa_full_ME<.
gen gpa_med_ME = (gpa_full_ME<3&gpa_full_ME>2) if gpa_full_ME<.
gen gpa_hi_ME = (gpa_full_ME>=3) if gpa_full_ME<.

egen f_gpa_ME_low = sum(gpa_low_ME==1&girls==1), by(sschlcde)
egen f_gpa_ME_med = sum(gpa_med_ME==1&girls==1), by(sschlcde)
egen f_gpa_ME_hi = sum(gpa_hi_ME==1&girls==1), by(sschlcde)

egen m_gpa_ME_low = sum(gpa_low_ME==1&girls==0), by(sschlcde)
egen m_gpa_ME_med = sum(gpa_med_ME==1&girls==0), by(sschlcde)
egen m_gpa_ME_hi = sum(gpa_hi_ME==1&girls==0), by(sschlcde)


*Generate WHITE-NON HISPANIC, BLACK, ASIAN*/
replace s6a = 0 if hisp == 1
replace s6d = 0 if hisp == 1
replace s6e = 0 if hisp == 1

replace s6a = 0 if s6b == 1
replace hisp = 0 if s6b == 1
replace s6c = 0 if s6b == 1
replace s6d = 0 if s6b == 1
replace s6e = 0 if s6b == 1

replace s6a = 0 if s6c == 1
replace hisp = 0 if s6c == 1
replace s6d = 0 if s6c == 1
replace s6e = 0 if s6c == 1

*Generate boys and girls in each grade by HS

egen Sgirl6 = sum(girl6), by(sschlcde)
egen Sgirl7 = sum(girl7), by(sschlcde)
egen Sgirl8 = sum(girl8), by(sschlcde)
egen Sgirl9 = sum(girl9), by(sschlcde)
egen Sgirl10 = sum(girl10), by(sschlcde)
egen Sgirl11 = sum(girl11), by(sschlcde)
egen Sgirl12 = sum(girl12), by(sschlcde)

egen Sboy6 = sum(boy6), by(sschlcde)
egen Sboy7 = sum(boy7), by(sschlcde)
egen Sboy8 = sum(boy8), by(sschlcde)
egen Sboy9 = sum(boy9), by(sschlcde)
egen Sboy10 = sum(boy10), by(sschlcde)
egen Sboy11 = sum(boy12), by(sschlcde)
egen Sboy12 = sum(boy12), by(sschlcde)

gen Total6 = Sboy6 + Sgirl6
gen Total7 = Sboy7 + Sgirl7
gen Total8 = Sboy8 + Sgirl8
gen Total9 = Sboy9 + Sgirl9
gen Total10 = Sboy10 + Sgirl10
gen Total11 = Sboy11 + Sgirl11
gen Total12 = Sboy12 + Sgirl12


*Generate Number of each each race per High School*/
gen whitboy = boys*s6a
gen whitgirl = girls*s6a  
gen hisboy = boys*hisp
gen hisgirl = girls*hisp
gen blkboy = boys*s6b
gen blkgirl = girls*s6b  
gen asnboy = boys*s6c
gen asngirl = girls*s6c  
gen otherboy = boys*other
gen othergirl= girls*other

gen whitboy9 = boys*s6a*Grade9
gen whitgirl9 = girls*s6a*Grade9  
gen hisboy9 = boys*hisp*Grade9
gen hisgirl9 = girls*hisp*Grade9
gen blkboy9 = boys*s6b*Grade9
gen blkgirl9 = girls*s6b*Grade9
gen asnboy9 = boys*s6c*Grade9
gen asngirl9 = girls*s6c*Grade9
gen otherboy9 = boys*other*Grade9
gen othergirl9 = girls*other*Grade9
gen whitboy10 = boys*s6a*Grade10
gen whitgirl10 = girls*s6a*Grade10
gen hisboy10 = boys*hisp*Grade10
gen hisgirl10 = girls*hisp*Grade10
gen blkboy10 = boys*s6b*Grade10
gen blkgirl10 = girls*s6b*Grade10  
gen asnboy10 = boys*s6c*Grade10
gen asngirl10 = girls*s6c*Grade10
gen otherboy10 = boys*other*Grade10
gen othergirl10 = girls*other*Grade10  
gen whitboy11 = boys*s6a*Grade11
gen whitgirl11 = girls*s6a*Grade11  
gen hisboy11 = boys*hisp*Grade11
gen hisgirl11 = girls*hisp*Grade11
gen blkboy11 = boys*s6b*Grade11
gen blkgirl11 = girls*s6b*Grade11  
gen asnboy11 = boys*s6c*Grade11
gen asngirl11 = girls*s6c*Grade11  
gen otherboy11 = boys*other*Grade11
gen othergirl11 = girls*other*Grade11
gen whitboy12 = boys*s6a*Grade12
gen whitgirl12 = girls*s6a*Grade12  
gen hisboy12 = boys*hisp*Grade12
gen hisgirl12 = girls*hisp*Grade12
gen blkboy12 = boys*s6b*Grade12
gen blkgirl12 = girls*s6b*Grade12  
gen asnboy12 = boys*s6c*Grade12
gen asngirl12 = girls*s6c*Grade12
gen otherboy12 = boys*other*Grade12
gen othergirl12 = girls*other*Grade12  

rename s6a white
rename s6b black
rename s6c asian

*Number of each race by high school*/
egen Swhite= sum(white), by(sschlcde)
egen Sblack= sum(black), by(sschlcde)
egen Shisp= sum(hisp), by(sschlcde)
egen Sasian= sum(asian), by(sschlcde)
egen Sother = sum(other), by(sschlcde)

*Number of Each Race by gender in each high school*/
egen Swhiboy = sum(whitboy), by(sschlcde)
egen Swhigirl = sum(whitgirl), by(sschlcde)
egen Sblkboy = sum(blkboy), by(sschlcde)
egen Sblkgirl = sum(blkgirl), by(sschlcde)
egen Sasnboy = sum(asnboy), by(sschlcde)
egen Sasngirl = sum(asngirl), by(sschlcde)
egen Shisboy = sum(hisboy), by(sschlcde)
egen Shisgirl = sum(hisgirl), by(sschlcde)
egen Sotherboy = sum(otherboy), by(sschlcde)
egen Sothergirl = sum(othergirl), by(sschlcde)

*Number of Each Race by Grade in each high school*/
egen Swhiboy9 = sum(whitboy9), by(sschlcde)
egen Swhigirl9 = sum(whitgirl9), by(sschlcde)
egen Sblkboy9 = sum(blkboy9), by(sschlcde)
egen Sblkgirl9 = sum(blkgirl9), by(sschlcde)
egen Sasnboy9 = sum(asnboy9), by(sschlcde)
egen Sasngirl9 = sum(asngirl9), by(sschlcde)
egen Shisboy9 = sum(hisboy9), by(sschlcde)
egen Shisgirl9 = sum(hisgirl9), by(sschlcde)
egen Sotherboy9 = sum(otherboy9), by(sschlcde)
egen Sothergirl9 = sum(othergirl9), by(sschlcde)

egen Swhiboy10 = sum(whitboy10), by(sschlcde)
egen Swhigirl10 = sum(whitgirl10), by(sschlcde)
egen Sblkboy10 = sum(blkboy10), by(sschlcde)
egen Sblkgirl10 = sum(blkgirl10), by(sschlcde)
egen Sasnboy10 = sum(asnboy10), by(sschlcde)
egen Sasngirl10 = sum(asngirl10), by(sschlcde)
egen Shisboy10 = sum(hisboy10), by(sschlcde)
egen Shisgirl10 = sum(hisgirl10), by(sschlcde)
egen Sotherboy10 = sum(otherboy10), by(sschlcde)
egen Sothergirl10 = sum(othergirl10), by(sschlcde)

egen Swhiboy11 = sum(whitboy11), by(sschlcde)
egen Swhigirl11 = sum(whitgirl11), by(sschlcde)
egen Sblkboy11 = sum(blkboy11), by(sschlcde)
egen Sblkgirl11 = sum(blkgirl11), by(sschlcde)
egen Sasnboy11 = sum(asnboy11), by(sschlcde)
egen Sasngirl11 = sum(asngirl11), by(sschlcde)
egen Shisboy11 = sum(hisboy11), by(sschlcde)
egen Shisgirl11 = sum(hisgirl11), by(sschlcde)
egen Sotherboy11 = sum(otherboy11), by(sschlcde)
egen Sothergirl11 = sum(othergirl11), by(sschlcde)

egen Swhiboy12 = sum(whitboy12), by(sschlcde)
egen Swhigirl12 = sum(whitgirl12), by(sschlcde)
egen Sblkboy12 = sum(blkboy12), by(sschlcde)
egen Sblkgirl12 = sum(blkgirl12), by(sschlcde)
egen Sasnboy12 = sum(asnboy12), by(sschlcde)
egen Sasngirl12 = sum(asngirl12), by(sschlcde)
egen Shisboy12 = sum(hisboy12), by(sschlcde)
egen Shisgirl12 = sum(hisgirl12), by(sschlcde)
egen Sotherboy12 = sum(otherboy12), by(sschlcde)
egen Sothergirl12 = sum(othergirl12), by(sschlcde)

*Generate High School Size 
egen Sboy = sum(boys), by(sschlcde)
egen Sgirl = sum(girls), by(sschlcde)
gen HSsize = 0
sort sschlcde
by sschlcde: replace HSsize = Sboy + Sgirl

*Calculate Gender Ratio per High School, By Race per High School*/

*Assuming Fi =0 */
by sschlcde: gen ip0WhiteGR = Swhigirl/(Swhiboy+Swhigirl) 
by sschlcde: gen ip0BlackGR = Sblkgirl/(Sblkboy+Sblkgirl) 
by sschlcde: gen ip0HispGR = Shisgirl/(Shisboy+Shisgirl) 
by sschlcde: gen ip0AsianGR = Sasngirl/(Sasnboy+Sasngirl) 
by sschlcde: gen ip0OtherGR = Sothergirl/(Sotherboy+Sothergirl) 

by sschlcde: gen ip0WhiteGRf = Swhiboy/(Swhiboy+Swhigirl) 
by sschlcde: gen ip0BlackGRf = Sblkboy/(Sblkboy+Sblkgirl) 
by sschlcde: gen ip0HispGRf = Shisboy/(Shisboy+Shisgirl)
by sschlcde: gen ip0AsianGRf = Sasnboy/(Sasnboy+Sasngirl) 
by sschlcde: gen ip0OtherGRf = Sotherboy/(Sotherboy+Sothergirl) 

replace ip0WhiteGR = 0 if ip0WhiteGR == . 
replace ip0BlackGR = 0 if ip0BlackGR == .
replace ip0HispGR =0 if ip0HispGR == . 
replace ip0AsianGR = 0 if ip0AsianGR == . 
replace ip0OtherGR = 0 if ip0OtherGR == . 
replace ip0WhiteGRf = 0 if ip0WhiteGRf == . 
replace ip0BlackGRf = 0 if ip0BlackGRf == .
replace ip0HispGRf =0 if ip0HispGRf == . 
replace ip0AsianGRf = 0 if ip0AsianGRf == . 
replace ip0OtherGRf = 0 if ip0OtherGRf == . 

*Assuming Fi =.25 */
by sschlcde: gen ip25WhiteGR = (Swhigirl + .25*(Sgirl - Swhigirl))/(Swhiboy+Swhigirl + .25*(HSsize -Swhiboy - Swhigirl)) 
by sschlcde: gen ip25BlackGR = (Sblkgirl + .25*(Sgirl - Sblkgirl))/(Sblkboy+Sblkgirl + .25*(HSsize -Sblkboy - Sblkgirl))
by sschlcde: gen ip25HispGR = (Shisgirl + .25*(Sgirl - Shisgirl))/(Shisboy+Shisgirl+ .25*(HSsize -Shisboy - Shisgirl)) 
by sschlcde: gen ip25AsianGR = (Sasngirl + .25*(Sgirl - Sasngirl))/(Sasnboy+Sasngirl+ .25*(HSsize -Sasnboy - Sasngirl)) 
by sschlcde: gen ip25OtherGR = (Sothergirl + .25*(Sgirl - Sothergirl))/(Sotherboy+Sothergirl + .25*(HSsize -Sotherboy - Sothergirl)) 
by sschlcde: gen ip25WhiteGRf = (Swhiboy + .25*(Sboy - Swhiboy))/(Swhiboy+Swhigirl + .25*(HSsize -Swhiboy - Swhigirl)) 
by sschlcde: gen ip25BlackGRf = (Sblkboy + .25*(Sboy - Sblkboy))/(Sblkboy+Sblkgirl + .25*(HSsize -Sblkboy - Sblkgirl)) 
by sschlcde: gen ip25HispGRf = (Shisboy + .25*(Sboy - Shisboy))/(Shisboy+Shisgirl+ .25*(HSsize -Shisboy - Shisgirl)) 
by sschlcde: gen ip25AsianGRf = (Sasnboy + .25*(Sboy - Sasnboy))/(Sasnboy+Sasngirl+ .25*(HSsize -Sasnboy - Sasngirl)) 
by sschlcde: gen ip25OtherGRf = (Sotherboy + .25*(Sboy - Sotherboy))/(Sotherboy+Sothergirl + .25*(HSsize -Sotherboy - Sothergirl)) 
replace ip25WhiteGR = 0 if ip25WhiteGR == . 
replace ip25BlackGR = 0 if ip25BlackGR == .
replace ip25HispGR =0 if ip25HispGR == .
replace ip25AsianGR = 0 if ip25AsianGR == .
replace ip25OtherGR = 0 if ip25OtherGR == .
replace ip25WhiteGRf = 0 if ip25WhiteGRf == . 
replace ip25BlackGRf = 0 if ip25BlackGRf == .
replace ip25HispGRf =0 if ip25HispGRf == .
replace ip25AsianGRf = 0 if ip25AsianGRf == .
replace ip25OtherGRf = 0 if ip25OtherGRf == .


*Assuming Fi =.5 */
by sschlcde: gen ip5WhiteGR = (Swhigirl + .5*(Sgirl - Swhigirl))/(Swhiboy+Swhigirl + .5*(HSsize -Swhiboy - Swhigirl)) 
by sschlcde: gen ip5BlackGR = (Sblkgirl + .5*(Sgirl - Sblkgirl))/(Sblkboy+Sblkgirl + .5*(HSsize -Sblkboy - Sblkgirl)) 
by sschlcde: gen ip5HispGR = (Shisgirl + .5*(Sgirl - Shisgirl))/(Shisboy+Shisgirl+ .5*(HSsize -Shisboy - Shisgirl)) 
by sschlcde: gen ip5AsianGR = (Sasngirl + .5*(Sgirl - Sasngirl))/(Sasnboy+Sasngirl+ .5*(HSsize -Sasnboy - Sasngirl)) 
by sschlcde: gen ip5OtherGR = (Sothergirl + .5*(Sgirl - Sothergirl))/(Sotherboy+Sothergirl + .5*(HSsize -Sotherboy - Sothergirl)) 
by sschlcde: gen ip5WhiteGRf = (Swhiboy + .5*(Sboy - Swhiboy))/(Swhiboy+Swhigirl + .5*(HSsize -Swhiboy - Swhigirl)) 
by sschlcde: gen ip5BlackGRf = (Sblkboy + .5*(Sboy - Sblkboy))/(Sblkboy+Sblkgirl + .5*(HSsize -Sblkboy - Sblkgirl))
by sschlcde: gen ip5HispGRf = (Shisboy + .5*(Sboy - Shisboy))/(Shisboy+Shisgirl+ .5*(HSsize -Shisboy - Shisgirl))
by sschlcde: gen ip5AsianGRf = (Sasnboy + .5*(Sboy - Sasnboy))/(Sasnboy+Sasngirl+ .5*(HSsize -Sasnboy - Sasngirl))
by sschlcde: gen ip5OtherGRf = (Sotherboy + .5*(Sboy - Sotherboy))/(Sotherboy+Sothergirl + .5*(HSsize -Sotherboy - Sothergirl)) 
replace ip5WhiteGR = 0 if ip5WhiteGR == .
replace ip5BlackGR = 0 if ip5BlackGR == .
replace ip5HispGR =0 if ip5HispGR == .
replace ip5AsianGR = 0 if ip5AsianGR == .
replace ip5OtherGR = 0 if ip5OtherGR == .
replace ip5WhiteGRf = 0 if ip5WhiteGRf == .
replace ip5BlackGRf = 0 if ip5BlackGRf == .
replace ip5HispGRf =0 if ip5HispGRf == .
replace ip5AsianGRf = 0 if ip5AsianGRf == .
replace ip5OtherGRf = 0 if ip5OtherGRf == .


*Assuming Fi =.75 */
by sschlcde: gen ip75WhiteGR = (Swhigirl + .75*(Sgirl - Swhigirl))/(Swhiboy+Swhigirl + .75*(HSsize -Swhiboy - Swhigirl))
by sschlcde: gen ip75BlackGR = (Sblkgirl + .75*(Sgirl - Sblkgirl))/(Sblkboy+Sblkgirl + .75*(HSsize -Sblkboy - Sblkgirl)) 
by sschlcde: gen ip75HispGR = (Shisgirl + .75*(Sgirl - Shisgirl))/(Shisboy+Shisgirl+ .75*(HSsize -Shisboy - Shisgirl))
by sschlcde: gen ip75AsianGR = (Sasngirl + .75*(Sgirl - Sasngirl))/(Sasnboy+Sasngirl+ .75*(HSsize -Sasnboy - Sasngirl))
by sschlcde: gen ip75OtherGR = (Sothergirl + .75*(Sgirl - Sothergirl))/(Sotherboy+Sothergirl + .75*(HSsize -Sotherboy - Sothergirl))
by sschlcde: gen ip75WhiteGRf = (Swhiboy + .75*(Sboy - Swhiboy))/(Swhiboy+Swhigirl + .75*(HSsize -Swhiboy - Swhigirl)) 
by sschlcde: gen ip75BlackGRf = (Sblkboy + .75*(Sboy - Sblkboy))/(Sblkboy+Sblkgirl + .75*(HSsize -Sblkboy - Sblkgirl)) 
by sschlcde: gen ip75HispGRf = (Shisboy + .75*(Sboy - Shisboy))/(Shisboy+Shisgirl+ .75*(HSsize -Shisboy - Shisgirl)) 
by sschlcde: gen ip75AsianGRf = (Sasnboy + .75*(Sboy - Sasnboy))/(Sasnboy+Sasngirl+ .75*(HSsize -Sasnboy - Sasngirl)) 
by sschlcde: gen ip75OtherGRf = (Sotherboy + .75*(Sboy - Sotherboy))/(Sotherboy+Sothergirl + .75*(HSsize -Sotherboy - Sothergirl)) 
replace ip75WhiteGR = 0 if ip75WhiteGR == .
replace ip75BlackGR = 0 if ip75BlackGR == .
replace ip75HispGR =0 if ip75HispGR == .
replace ip75AsianGR = 0 if ip75AsianGR == .
replace ip75OtherGR = 0 if ip75OtherGR == .
replace ip75WhiteGRf = 0 if ip75WhiteGRf == .
replace ip75BlackGRf = 0 if ip75BlackGRf == .
replace ip75HispGRf =0 if ip75HispGRf == .
replace ip75AsianGRf = 0 if ip75AsianGRf == .
replace ip75OtherGRf = 0 if ip75OtherGRf == .


*Assuming Fi = 1*/
by sschlcde: gen genrat = Sgirl/HSsize
by sschlcde: gen ip1WhiteGR = (Swhigirl + 1*(Sgirl - Swhigirl))/(Swhiboy + Swhigirl + (HSsize -Swhiboy - Swhigirl))
by sschlcde: gen ip1BlackGR = (Sblkgirl + 1*(Sgirl - Sblkgirl))/(Sblkboy + Sblkgirl + (HSsize -Sblkboy - Sblkgirl)) 
by sschlcde: gen ip1HispGR = (Shisgirl + 1*(Sgirl - Shisgirl))/(Shisboy + Shisgirl+ (HSsize -Shisboy - Shisgirl))
by sschlcde: gen ip1AsianGR = (Sasngirl + 1*(Sgirl - Sasngirl))/(Sasnboy + Sasngirl+ (HSsize -Sasnboy - Sasngirl)) 
by sschlcde: gen ip1OtherGR = (Sothergirl + 1*(Sgirl - Sothergirl))/(Sotherboy + Sothergirl + (HSsize -Sotherboy - Sothergirl)) 

by sschlcde: gen ip1WhiteGRf = (Swhiboy + 1*(Sboy - Swhiboy))/(Swhiboy+Swhigirl + 1*(HSsize -Swhiboy - Swhigirl))
by sschlcde: gen ip1BlackGRf = (Sblkboy + 1*(Sboy - Sblkboy))/(Sblkboy+blkgirl + 1*(HSsize -Sblkboy - Sblkgirl)) 
by sschlcde: gen ip1HispGRf = (Shisboy + 1*(Sboy - Shisboy))/(Shisboy+Shisgirl+ 1*(HSsize -Shisboy - Shisgirl))
by sschlcde: gen ip1AsianGRf = (Sasnboy + 1*(Sboy - Sasnboy))/(Sasnboy+Sasngirl+ 1*(HSsize -Sasnboy - Sasngirl)) 
by sschlcde: gen ip1OtherGRf = (Sotherboy + 1*(Sboy - Sotherboy))/(Sotherboy+Sothergirl + 1*(HSsize -Sotherboy - Sothergirl))
replace ip1WhiteGR = 0 if ip1WhiteGR == .
replace ip1BlackGR = 0 if ip1BlackGR == .
replace ip1HispGR =0 if ip1HispGR == .
replace ip1AsianGR = 0 if ip1AsianGR == .
replace ip1OtherGR = 0 if ip1OtherGR == .
replace ip1WhiteGRf = 0 if ip1WhiteGRf == .
replace ip1BlackGRf = 0 if ip1BlackGRf == .
replace ip1HispGRf =0 if ip1HispGRf == .
replace ip1AsianGRf = 0 if ip1AsianGRf == .
replace ip1OtherGRf = 0 if ip1OtherGRf == .

*Calculate Gender Ratio by Grade*/
by sschlcde: gen iGR9th = Sgirl9/(Sgirl9 + Sboy9)
by sschlcde: gen iGR10th = Sgirl10/(Sgirl10 + Sboy10)
by sschlcde: gen iGR11th = Sgirl11/(Sgirl11 + Sboy11)
by sschlcde: gen iGR12th = Sgirl12/(Sgirl12 + Sboy12)
replace iGR9th = 0 if iGR9th == .
replace iGR10th =0 if iGR10th == .
replace iGR11th = 0 if iGR11th == .
replace iGR12th = 0 if iGR12th == .

*Calculate Gender Ratio by Grade and Race */
by sschlcde: gen iGR91 = Swhigirl9/(Swhiboy9 + Swhigirl9)
by sschlcde: gen iGR101 = Swhigirl10/(Swhiboy10 + Swhigirl10)
by sschlcde: gen iGR111 = Swhigirl11/(Swhiboy11 + Swhigirl11)
by sschlcde: gen iGR121 = Swhigirl12/(Swhiboy12 + Swhigirl12)
by sschlcde: gen iGR92 = Sblkgirl9/(Sblkboy9 + Sblkgirl9)
by sschlcde: gen iGR102 = Sblkgirl10/(Sblkboy10 + Sblkgirl10)
by sschlcde: gen iGR112 = Sblkgirl11/(Sblkboy11 + Sblkgirl11)
by sschlcde: gen iGR122 = Sblkgirl12/(Sblkboy12 + Sblkgirl12)
by sschlcde: gen iGR93 = Shisgirl9/(Shisboy9 + Shisgirl9)
by sschlcde: gen iGR103 = Shisgirl10/(Shisboy10 + Shisgirl10)
by sschlcde: gen iGR113 = Shisgirl11/(Shisboy11 + Shisgirl11)
by sschlcde: gen iGR123 = Shisgirl12/(Shisboy12 + Shisgirl12)
by sschlcde: gen iGR94 = Sasngirl9/(Sasnboy9 + Sasngirl9)
by sschlcde: gen iGR104 = Sasngirl10/(Sasnboy10 + Sasngirl10)
by sschlcde: gen iGR114 = Sasngirl11/(Sasnboy11 + Sasngirl11)
by sschlcde: gen iGR124 = Sasngirl12/(Sasnboy12 + Sasngirl12)
by sschlcde: gen iGR95 = Sothergirl9/(Sotherboy9 + Sothergirl9)
by sschlcde: gen iGR105 = Sothergirl10/(Sotherboy10 + Sothergirl10)
by sschlcde: gen iGR115 = Sothergirl11/(Sotherboy11 + Sothergirl11)
by sschlcde: gen iGR125 = Sothergirl12/(Sotherboy12 + Sothergirl12)


replace iGR91 = 0 if iGR91 == .
replace iGR101 = 0 if iGR101 == .
replace iGR111 = 0 if iGR111 == .
replace iGR121 = 0 if iGR121 == .
replace iGR92 = 0 if iGR92 == .
replace iGR102 = 0 if iGR102 == .
replace iGR112 = 0 if iGR112 == .
replace iGR122 = 0 if iGR122 == .
replace iGR93 = 0 if iGR93 == .
replace iGR103 = 0 if iGR103 == .
replace iGR113 = 0 if iGR113 == .
replace iGR123 = 0 if iGR123 == .
replace iGR94 = 0 if iGR94 == .
replace iGR104 = 0 if iGR104 == .
replace iGR114 = 0 if iGR114 == .
replace iGR124 = 0 if iGR124 == .
replace iGR95 = 0 if iGR95 == .
replace iGR105 = 0 if iGR105 == .
replace iGR115 = 0 if iGR115 == .
replace iGR125 = 0 if iGR125 == .

joinby sschlcde using  1st.dta, unm(m)

la var asize "School Size, 1 is < 400, 2 is 401-1000, 3 is 1001-4000"
la var atype "public =1, private =2"
la var aurban "1=Urban, 2=Suburban, 3=Rural"
la var aregion "1=west, 2=midwest, 3=south, 4=northeast"

drop _merge

save 2nd.dta, replace

