******************************************************
*Removes unweighted observations, and prepares in-home
*	data for estimation via MATLAB programs.
*		By Andrew Beauchamp
*		June 1 2006
******************************************************


clear 
set mem 1g
set maxvar 10000
use "4th.dta"

*Adding information for those in In-Home and not in In-School
gen whitboy9new = 0  
replace whitboy9new = 1 if race == 1 & girls == 0 &  grade == 9 & whitboy9 == . 
gen whitboy10new = 0   
replace whitboy10new = 1 if race == 1 & girls == 0 &  grade == 10 & whitboy10 == .
gen whitboy11new = 0    
replace whitboy11new = 1 if race == 1 & girls == 0 &  grade == 11 & whitboy11 == .
gen whitboy12new = 0  
replace whitboy12new = 1 if race == 1 & girls == 0 & grade == 12 & whitboy12 == . 

gen whitgirl9new = 0  
replace whitgirl9new = 1 if race == 1 & girls == 1 & grade == 9 & whitboy9 == . 
gen whitgirl10new = 0   
replace whitgirl10new = 1 if race == 1 & girls == 1 & grade == 10 & whitgirl10 == .
gen whitgirl11new = 0    
replace whitgirl11new = 1 if race == 1 & girls == 1 & grade == 11 & whitgirl11 == .
gen whitgirl12new = 0  
replace whitgirl12new = 1 if race == 1 & girls == 1 & grade == 12 & whitgirl12 == . 

gen blkboy9new = 0  
replace blkboy9new = 1 if race == 2 & girls == 0 &  grade == 9 & blkboy9 == . 
gen blkboy10new = 0   
replace blkboy10new = 1 if race == 2 & girls == 0 &  grade == 10 & blkboy10 == .
gen blkboy11new = 0    
replace blkboy11new = 1 if race == 2 & girls == 0 &  grade == 11 & blkboy11 == .
gen blkboy12new = 0  
replace blkboy12new = 1 if race == 2 & girls == 0 & grade == 12 & blkboy12 == . 

gen blkgirl9new = 0  
replace blkgirl9new = 1 if race == 2 & girls == 1 & grade == 9 & blkboy9 == . 
gen blkgirl10new = 0   
replace blkgirl10new = 1 if race == 2 & girls == 1 & grade == 10 & blkgirl10 == .
gen blkgirl11new = 0    
replace blkgirl11new = 1 if race == 2 & girls == 1 & grade == 11 & blkgirl11 == .
gen blkgirl12new = 0  
replace blkgirl12new = 1 if race == 2 & girls == 1 & grade == 12 & blkgirl12 == . 

gen hisboy9new = 0  
replace hisboy9new = 1 if race == 3 & girls == 0 &  grade == 9 & hisboy9 == . 
gen hisboy10new = 0   
replace hisboy10new = 1 if race == 3 & girls == 0 &  grade == 10 & hisboy10 == .
gen hisboy11new = 0    
replace hisboy11new = 1 if race == 3 & girls == 0 &  grade == 11 & hisboy11 == .
gen hisboy12new = 0  
replace hisboy12new = 1 if race == 3 & girls == 0 & grade == 12 & hisboy12 == . 

gen hisgirl9new = 0  
replace hisgirl9new = 1 if race == 3 & girls == 1 & grade == 9 & hisboy9 == . 
gen hisgirl10new = 0   
replace hisgirl10new = 1 if race == 3 & girls == 1 & grade == 10 & hisgirl10 == .
gen hisgirl11new = 0    
replace hisgirl11new = 1 if race == 3 & girls == 1 & grade == 11 & hisgirl11 == .
gen hisgirl12new = 0  
replace hisgirl12new = 1 if race == 3 & girls == 1 & grade == 12 & hisgirl12 == . 

gen asnboy9new = 0  
replace asnboy9new = 1 if race == 4 & girls == 0 &  grade == 9 & asnboy9 == . 
gen asnboy10new = 0   
replace asnboy10new = 1 if race == 4 & girls == 0 &  grade == 10 & asnboy10 == .
gen asnboy11new = 0    
replace asnboy11new = 1 if race == 4 & girls == 0 &  grade == 11 & asnboy11 == .
gen asnboy12new = 0  
replace asnboy12new = 1 if race == 4 & girls == 0 & grade == 12 & asnboy12 == . 

gen asngirl9new = 0  
replace asngirl9new = 1 if race == 4 & girls == 1 & grade == 9 & asnboy9 == . 
gen asngirl10new = 0   
replace asngirl10new = 1 if race == 4 & girls == 1 & grade == 10 & asngirl10 == .
gen asngirl11new = 0    
replace asngirl11new = 1 if race == 4 & girls == 1 & grade == 11 & asngirl11 == .
gen asngirl12new = 0  
replace asngirl12new = 1 if race == 4 & girls == 1 & grade == 12 & asngirl12 == . 

gen otherboy9new = 0  
replace otherboy9new = 1 if race == 5 & girls == 0 &  grade == 9 & otherboy9 == . 
gen otherboy10new = 0   
replace otherboy10new = 1 if race == 5 & girls == 0 &  grade == 10 & otherboy10 == .
gen otherboy11new = 0    
replace otherboy11new = 1 if race == 5 & girls == 0 &  grade == 11 & otherboy11 == .
gen otherboy12new = 0  
replace otherboy12new = 1 if race == 5 & girls == 0 & grade == 12 & otherboy12 == . 

gen othergirl9new = 0  
replace othergirl9new = 1 if race == 5 & girls == 1 & grade == 9 & otherboy9 == . 
gen othergirl10new = 0   
replace othergirl10new = 1 if race == 5 & girls == 1 & grade == 10 & othergirl10 == .
gen othergirl11new = 0    
replace othergirl11new = 1 if race == 5 & girls == 1 & grade == 11 & othergirl11 == .
gen othergirl12new = 0  
replace othergirl12new = 1 if race == 5 & girls == 1 & grade == 12 & othergirl12 == .  

egen hsg9r1sm_new = total(whitboy9new==1), by(scid)
egen hsg10r1sm_new = total(whitboy10new==1), by(scid)
egen hsg11r1sm_new = total(whitboy11new==1), by(scid)
egen hsg12r1sm_new = total(whitboy12new==1), by(scid)
egen hsg9r1sf_new = total(whitgirl9new==1), by(scid)
egen hsg10r1sf_new = total(whitgirl10new==1), by(scid)
egen hsg11r1sf_new = total(whitgirl11new==1), by(scid)
egen hsg12r1sf_new = total(whitgirl12new==1), by(scid)

egen hsg9r2sm_new = total(blkboy9new==1), by(scid)
egen hsg10r2sm_new = total(blkboy10new==1), by(scid)
egen hsg11r2sm_new = total(blkboy11new==1), by(scid)
egen hsg12r2sm_new = total(blkboy12new==1), by(scid)
egen hsg9r2sf_new = total(blkgirl9new==1), by(scid)
egen hsg10r2sf_new = total(blkgirl10new==1), by(scid)
egen hsg11r2sf_new = total(blkgirl11new==1), by(scid)
egen hsg12r2sf_new = total(blkgirl12new==1), by(scid)

egen hsg9r3sm_new = total(hisboy9new==1), by(scid)
egen hsg10r3sm_new = total(hisboy10new==1), by(scid)
egen hsg11r3sm_new = total(hisboy11new==1), by(scid)
egen hsg12r3sm_new = total(hisboy12new==1), by(scid)
egen hsg9r3sf_new = total(hisgirl9new==1), by(scid)
egen hsg10r3sf_new = total(hisgirl10new==1), by(scid)
egen hsg11r3sf_new = total(hisgirl11new==1), by(scid)
egen hsg12r3sf_new = total(hisgirl12new==1), by(scid)

egen hsg9r4sm_new = total(asnboy9new==1), by(scid)
egen hsg10r4sm_new = total(asnboy10new==1), by(scid)
egen hsg11r4sm_new = total(asnboy11new==1), by(scid)
egen hsg12r4sm_new = total(asnboy12new==1), by(scid)
egen hsg9r4sf_new = total(asngirl9new==1), by(scid)
egen hsg10r4sf_new = total(asngirl10new==1), by(scid)
egen hsg11r4sf_new = total(asngirl11new==1), by(scid)
egen hsg12r4sf_new = total(asngirl12new==1), by(scid)

egen hsg9r5sm_new = total(otherboy9new==1), by(scid)
egen hsg10r5sm_new = total(otherboy10new==1), by(scid)
egen hsg11r5sm_new = total(otherboy11new==1), by(scid)
egen hsg12r5sm_new = total(otherboy12new==1), by(scid)
egen hsg9r5sf_new = total(othergirl9new==1), by(scid)
egen hsg10r5sf_new = total(othergirl10new==1), by(scid)
egen hsg11r5sf_new = total(othergirl11new==1), by(scid)
egen hsg12r5sf_new = total(othergirl12new==1), by(scid)

replace Swhiboy9 = 0 if Swhiboy9 == .
replace Swhigirl9 = 0 if Swhigirl9 == .
replace Swhiboy10 = 0 if Swhiboy10 == .
replace Swhigirl10 = 0 if Swhigirl10 == .
replace Swhiboy11 = 0 if Swhiboy11 == .
replace Swhigirl11 = 0 if Swhigirl11 == .
replace Swhiboy12 = 0 if Swhiboy12 == .
replace Swhigirl12 = 0 if Swhigirl12 == .
replace Sblkboy9 = 0 if Sblkboy9 == .
replace Sblkgirl9 = 0 if Sblkgirl9 == .
replace Sblkboy10 = 0 if Sblkboy10 == .
replace Sblkgirl10 = 0 if Sblkgirl10 == .
replace Sblkboy11 = 0 if Sblkboy11 == .
replace Sblkgirl11 = 0 if Sblkgirl11 == .
replace Sblkboy12 = 0 if Sblkboy12 == .
replace Sblkgirl12 = 0 if Sblkgirl12 == .
replace Shisboy9 = 0 if Shisboy9 == .
replace Shisgirl9 = 0 if Shisgirl9 == .
replace Shisboy10 = 0 if Shisboy10 == .
replace Shisgirl10 = 0 if Shisgirl10 == .
replace Shisboy11 = 0 if Shisboy11 == .
replace Shisgirl11 = 0 if Shisgirl11 == .
replace Shisboy12 = 0 if Shisboy12 == .
replace Shisgirl12 = 0 if Shisgirl12 == .
replace Sasnboy9 = 0 if Sasnboy9 == .
replace Sasngirl9 = 0 if Sasngirl9 == .
replace Sasnboy10 = 0 if Sasnboy10 == .
replace Sasngirl10 = 0 if Sasngirl10 == .
replace Sasnboy11 = 0 if Sasnboy11 == .
replace Sasngirl11 = 0 if Sasngirl11 == .
replace Sasnboy12 = 0 if Sasnboy12 == .
replace Sasngirl12 = 0 if Sasngirl12 == .
replace Sotherboy9 = 0 if Sotherboy9 == .
replace Sothergirl9 = 0 if Sothergirl9 == .
replace Sotherboy10 = 0 if Sotherboy10 == .
replace Sothergirl10 = 0 if Sothergirl10 == .
replace Sotherboy11 = 0 if Sotherboy11 == .
replace Sothergirl11 = 0 if Sothergirl11 == .
replace Sotherboy12 = 0 if Sotherboy12 == .
replace Sothergirl12 = 0 if Sothergirl12 == .

*Updating School Level Counts
egen hsg9r1sm = max(hsg9r1sm_new + Swhiboy9), by(scid)
egen hsg10r1sm = max(hsg10r1sm_new + Swhiboy10), by(scid)
egen hsg11r1sm = max(hsg11r1sm_new + Swhiboy11), by(scid)
egen hsg12r1sm = max(hsg12r1sm_new + Swhiboy12), by(scid)
egen hsg9r1sf = max(hsg9r1sf_new + Swhigirl9), by(scid)
egen hsg10r1sf = max(hsg10r1sf_new + Swhigirl10), by(scid)
egen hsg11r1sf = max(hsg11r1sf_new + Swhigirl11), by(scid)
egen hsg12r1sf = max(hsg12r1sf_new + Swhigirl12), by(scid)
egen hsg9r2sm = max(hsg9r2sm_new + Sblkboy9), by(scid)
egen hsg10r2sm = max(hsg10r2sm_new + Sblkboy10), by(scid)
egen hsg11r2sm = max(hsg11r2sm_new + Sblkboy11), by(scid)
egen hsg12r2sm = max(hsg12r2sm_new + Sblkboy12), by(scid)
egen hsg9r2sf = max(hsg9r2sf_new + Sblkgirl9), by(scid)
egen hsg10r2sf = max(hsg10r2sf_new + Sblkgirl10), by(scid)
egen hsg11r2sf = max(hsg11r2sf_new + Sblkgirl11), by(scid)
egen hsg12r2sf = max(hsg12r2sf_new + Sblkgirl12), by(scid)

egen hsg9r3sm = max(hsg9r3sm_new + Shisboy9), by(scid)
egen hsg10r3sm = max(hsg10r3sm_new + Shisboy10), by(scid)
egen hsg11r3sm = max(hsg11r3sm_new + Shisboy11), by(scid)
egen hsg12r3sm = max(hsg12r3sm_new + Shisboy12), by(scid)
egen hsg9r3sf = max(hsg9r3sf_new + Shisgirl9), by(scid)
egen hsg10r3sf = max(hsg10r3sf_new + Shisgirl10), by(scid)
egen hsg11r3sf = max(hsg11r3sf_new + Shisgirl11), by(scid)
egen hsg12r3sf = max(hsg12r3sf_new + Shisgirl12), by(scid)

egen hsg9r4sm = max(hsg9r4sm_new + Sasnboy9), by(scid)
egen hsg10r4sm = max(hsg10r4sm_new + Sasnboy10), by(scid)
egen hsg11r4sm = max(hsg11r4sm_new + Sasnboy11), by(scid)
egen hsg12r4sm = max(hsg12r4sm_new + Sasnboy12), by(scid)
egen hsg9r4sf = max(hsg9r4sf_new + Sasngirl9), by(scid)
egen hsg10r4sf = max(hsg10r4sf_new + Sasngirl10), by(scid)
egen hsg11r4sf = max(hsg11r4sf_new + Sasngirl11), by(scid)
egen hsg12r4sf = max(hsg12r4sf_new + Sasngirl12), by(scid)

egen hsg9r5sm = max(hsg9r5sm_new + Sotherboy9), by(scid)
egen hsg10r5sm = max(hsg10r5sm_new + Sotherboy10), by(scid)
egen hsg11r5sm = max(hsg11r5sm_new + Sotherboy11), by(scid)
egen hsg12r5sm = max(hsg12r5sm_new + Sotherboy12), by(scid)
egen hsg9r5sf = max(hsg9r5sf_new + Sothergirl9), by(scid)
egen hsg10r5sf = max(hsg10r5sf_new + Sothergirl10), by(scid)
egen hsg11r5sf = max(hsg11r5sf_new + Sothergirl11), by(scid)
egen hsg12r5sf = max(hsg12r5sf_new + Sothergirl12), by(scid)

**********************************************************
*Updating School Level GPA's
**********************************************************
*Filling in distributions for those not In School

egen f_gpa_low_rep = mode(f_gpa_low), by(scid)
replace f_gpa_low = f_gpa_low_rep if f_gpa_low == .
egen f_gpa_med_rep = mode(f_gpa_med), by(scid)
replace f_gpa_med = f_gpa_med_rep if f_gpa_med == .
egen f_gpa_hi_rep = mode(f_gpa_hi), by(scid)
replace f_gpa_hi = f_gpa_hi_rep if f_gpa_hi == .

egen m_gpa_low_rep = mode(m_gpa_low), by(scid)
replace m_gpa_low = m_gpa_low_rep if m_gpa_low == .
egen m_gpa_med_rep = mode(m_gpa_med), by(scid)
replace m_gpa_med = m_gpa_med_rep if m_gpa_med == .
egen m_gpa_hi_rep = mode(m_gpa_hi), by(scid)
replace m_gpa_hi = m_gpa_hi_rep if m_gpa_hi == .

egen f_gpa_ME_low_rep = mode(f_gpa_ME_low), by(scid)
replace f_gpa_ME_low = f_gpa_ME_low_rep if f_gpa_ME_low == .
egen f_gpa_ME_med_rep = mode(f_gpa_ME_med), by(scid)
replace f_gpa_ME_med = f_gpa_ME_med_rep if f_gpa_ME_med == .
egen f_gpa_ME_hi_rep = mode(f_gpa_ME_hi), by(scid)
replace f_gpa_ME_hi = f_gpa_ME_hi_rep if f_gpa_ME_hi == .

egen m_gpa_ME_low_rep = mode(m_gpa_ME_low), by(scid)
replace m_gpa_ME_low = m_gpa_ME_low_rep if m_gpa_ME_low == .
egen m_gpa_ME_med_rep = mode(m_gpa_ME_med), by(scid)
replace m_gpa_ME_med = m_gpa_ME_med_rep if m_gpa_ME_med == .
egen m_gpa_ME_hi_rep = mode(m_gpa_ME_hi), by(scid)
replace m_gpa_ME_hi = m_gpa_ME_hi_rep if m_gpa_ME_hi == .

*Calculating GPA's from In Home
gen gpa_inhome = (h1ed11+h1ed12+h1ed13+h1ed14)/4 if h1ed11<5&h1ed12<5&h1ed13<5&h1ed14<5

gen gpa_low_inhome = (gpa_inhome<2) if gpa_inhome<.&gpa_full==.
gen gpa_med_inhome = (gpa_inhome<3&gpa_inhome>2) if gpa_inhome<.&gpa_full==.
gen gpa_hi_inhome = (gpa_inhome>=3) if gpa_inhome<.&gpa_full==.

egen m_gpa_low_ih = total(gpa_low_inhome==1&girls==0), by(scid)
egen m_gpa_med_ih = total(gpa_med_inhome==1&girls==0), by(scid)
egen m_gpa_hi_ih = total(gpa_hi_inhome==1&girls==0), by(scid)

egen f_gpa_low_ih = total(gpa_low_inhome==1&girls==1), by(scid)
egen f_gpa_med_ih = total(gpa_med_inhome==1&girls==1), by(scid)
egen f_gpa_hi_ih = total(gpa_hi_inhome==1&girls==1), by(scid)


gen gpa_inhome_ME = (h1ed11+h1ed12)/2 if h1ed11<5&h1ed12<5

gen gpa_low_inhome_ME = (gpa_inhome_ME<2) if gpa_inhome_ME<.&gpa_full_ME==.
gen gpa_med_inhome_ME = (gpa_inhome_ME<3&gpa_inhome_ME>2) if gpa_inhome_ME<.&gpa_full_ME==.
gen gpa_hi_inhome_ME = (gpa_inhome_ME>=3) if gpa_inhome_ME<.&gpa_full_ME==.

egen m_gpa_ME_low_ih = total(gpa_low_inhome_ME==1&girls==0), by(scid)
egen m_gpa_ME_med_ih = total(gpa_med_inhome_ME==1&girls==0), by(scid)
egen m_gpa_ME_hi_ih = total(gpa_hi_inhome_ME==1&girls==0), by(scid)

egen f_gpa_ME_low_ih = total(gpa_low_inhome_ME==1&girls==1), by(scid)
egen f_gpa_ME_med_ih = total(gpa_med_inhome_ME==1&girls==1), by(scid)
egen f_gpa_ME_hi_ih = total(gpa_hi_inhome_ME==1&girls==1), by(scid)

*Combining Observations from In Home-In school

gen  f_gpa_low_t =  f_gpa_low +  f_gpa_low_ih
gen  f_gpa_med_t =  f_gpa_med +  f_gpa_med_ih
gen  f_gpa_hi_t =  f_gpa_hi +  f_gpa_hi_ih

gen  m_gpa_low_t =  m_gpa_low +  m_gpa_low_ih
gen  m_gpa_med_t =  m_gpa_med +  m_gpa_med_ih
gen  m_gpa_hi_t =  m_gpa_hi +  m_gpa_hi_ih

gen  f_gpa_ME_low_t =  f_gpa_ME_low +  f_gpa_ME_low_ih
gen  f_gpa_ME_med_t =  f_gpa_ME_med +  f_gpa_ME_med_ih
gen  f_gpa_ME_hi_t =  f_gpa_ME_hi +  f_gpa_ME_hi_ih

gen  m_gpa_ME_low_t =  m_gpa_ME_low +  m_gpa_ME_low_ih
gen  m_gpa_ME_med_t =  m_gpa_ME_med +  m_gpa_ME_med_ih
gen  m_gpa_ME_hi_t =   m_gpa_ME_hi +  m_gpa_ME_hi_ih








***********************************************************
*Gender Ratio's for 9-12th grades
***********************************************************
gen hsr1 = hsg9r1sm + hsg9r1sf + hsg10r1sm + hsg10r1sf + hsg11r1sm + hsg11r1sf + hsg12r1sm + hsg12r1sf
gen hsr2 = hsg9r2sm + hsg9r2sf + hsg10r2sm + hsg10r2sf + hsg11r2sm + hsg11r2sf + hsg12r2sm + hsg12r2sf
gen hsr3 = hsg9r3sm + hsg9r3sf + hsg10r3sm + hsg10r3sf + hsg11r3sm + hsg11r3sf + hsg12r3sm + hsg12r3sf
gen hsr4 = hsg9r4sm + hsg9r4sf + hsg10r4sm + hsg10r4sf + hsg11r4sm + hsg11r4sf + hsg12r4sm + hsg12r4sf
gen hsr5 = hsg9r5sm + hsg9r5sf + hsg10r5sm + hsg10r5sf + hsg11r5sm + hsg11r5sf + hsg12r5sm + hsg12r5sf
gen hsr1sf = hsg9r1sf + hsg10r1sf + hsg11r1sf + hsg12r1sf
gen hsr2sf = hsg9r2sf + hsg10r2sf + hsg11r2sf + hsg12r2sf
gen hsr3sf = hsg9r3sf + hsg10r3sf + hsg11r3sf + hsg12r3sf
gen hsr4sf = hsg9r4sf + hsg10r4sf + hsg11r4sf + hsg12r4sf
gen hsr5sf = hsg9r5sf + hsg10r5sf + hsg11r5sf + hsg12r5sf
gen hsr1sm = hsg9r1sm + hsg10r1sm + hsg11r1sm + hsg12r1sm
gen hsr2sm = hsg9r2sm + hsg10r2sm + hsg11r2sm + hsg12r2sm
gen hsr3sm = hsg9r3sm + hsg10r3sm + hsg11r3sm + hsg12r3sm
gen hsr4sm = hsg9r4sm + hsg10r4sm + hsg11r4sm + hsg12r4sm
gen hsr5sm = hsg9r5sm + hsg10r5sm + hsg11r5sm + hsg12r5sm

gen hs = hsr1+hsr2+hsr3+hsr4+hsr5
gen hsm = hsr1sm+hsr2sm+hsr3sm+hsr4sm+hsr5sm
gen hsf =  hsr1sf+hsr2sf+hsr3sf+hsr4sf+hsr5sf

gen gr = (hsr1sm+hsr2sm+hsr3sm+hsr4sm+hsr5sm)/hsf
gen grpctf = (hsr1sf+hsr2sf+hsr3sf+hsr4sf+hsr5sf)/(hsm+hsf)

gen grw = hsr1sm/hsr1sf
gen grb = hsr2sm/hsr2sf
gen grh = hsr3sm/hsr3sf
gen gra = hsr4sm/hsr4sf
gen gro = hsr5sm/hsr5sf
gen grwpctf = hsr1sf/(hsr1sf+hsr1sm)
gen grw9pctf = hsg9r1sf/(hsg9r1sf+hsg9r1sm)
gen grw10pctf = hsg10r1sf/(hsg10r1sf+hsg10r1sm)
gen grw11pctf = hsg11r1sf/(hsg11r1sf+hsg11r1sm)
gen grw12pctf = hsg12r1sf/(hsg12r1sf+hsg12r1sm)

gen grbpctf = hsr2sf/(hsr2sf+hsr2sm)
gen grb9pctf = hsg9r2sf/(hsg9r2sf+hsg9r2sm)
gen grb10pctf = hsg10r2sf/(hsg10r2sf+hsg10r2sm)
gen grb11pctf = hsg11r2sf/(hsg11r2sf+hsg11r2sm)
gen grb12pctf = hsg12r2sf/(hsg12r2sf+hsg12r2sm)

gen grhpctf = hsr3sf/(hsr3sf+hsr3sm)
gen grh9pctf = hsg9r3sf/(hsg9r3sf+hsg9r3sm)
gen grh10pctf = hsg10r3sf/(hsg10r3sf+hsg10r3sm)
gen grh11pctf = hsg11r3sf/(hsg11r3sf+hsg11r3sm)
gen grh12pctf = hsg12r3sf/(hsg12r3sf+hsg12r3sm)

gen grapctf = hsr4sf/(hsr4sf+hsr4sm)
gen gra9pctf = hsg9r4sf/(hsg9r4sf+hsg9r4sm)
gen gra10pctf = hsg10r4sf/(hsg10r4sf+hsg10r4sm)
gen gra11pctf = hsg11r4sf/(hsg11r4sf+hsg11r4sm)
gen gra12pctf = hsg12r4sf/(hsg12r4sf+hsg12r4sm)

gen gropctf = hsr5sf/(hsr5sf+hsr5sm)
gen gro9pctf = hsg9r5sf/(hsg9r5sf+hsg9r5sm)
gen gro10pctf = hsg10r5sf/(hsg10r5sf+hsg10r5sm)
gen gro11pctf = hsg11r5sf/(hsg11r5sf+hsg11r5sm)
gen gro12pctf = hsg12r5sf/(hsg12r5sf+hsg12r5sm)

*Generating Individual Level Types
gen g9r1sm = 0
replace g9r1sm = 1 if whitboy9 == 1 | whitboy9new == 1
gen g10r1sm = 0
replace g10r1sm = 1 if whitboy10 == 1 | whitboy10new == 1
gen g11r1sm = 0
replace g11r1sm = 1 if whitboy11 == 1 | whitboy11new == 1
gen g12r1sm = 0
replace g12r1sm = 1 if whitboy12 == 1 | whitboy12new == 1
gen g9r1sf = 0
replace g9r1sf = 1 if whitgirl9 == 1 | whitgirl9new == 1
gen g10r1sf = 0
replace g10r1sf = 1 if whitgirl10 == 1 | whitgirl10new == 1
gen g11r1sf = 0
replace g11r1sf = 1 if whitgirl11 == 1 | whitgirl11new == 1
gen g12r1sf = 0
replace g12r1sf = 1 if whitgirl12 == 1 | whitgirl12new == 1
gen g9r2sm = 0
replace g9r2sm = 1 if blkboy9 == 1 | blkboy9new == 1
gen g10r2sm = 0
replace g10r2sm = 1 if blkboy10 == 1 | blkboy10new == 1
gen g11r2sm = 0
replace g11r2sm = 1 if blkboy11 == 1 | blkboy11new == 1
gen g12r2sm = 0
replace g12r2sm = 1 if blkboy12 == 1 | blkboy12new == 1
gen g9r2sf = 0
replace g9r2sf = 1 if blkgirl9 == 1 | blkgirl9new == 1
gen g10r2sf = 0
replace g10r2sf = 1 if blkgirl10 == 1 | blkgirl10new == 1
gen g11r2sf = 0
replace g11r2sf = 1 if blkgirl11 == 1 | blkgirl11new == 1
gen g12r2sf = 0
replace g12r2sf = 1 if blkgirl12 == 1 | blkgirl12new == 1

gen g9r3sm = 0
replace g9r3sm = 1 if hisboy9 == 1 | hisboy9new == 1
gen g10r3sm = 0
replace g10r3sm = 1 if hisboy10 == 1 | hisboy10new == 1
gen g11r3sm = 0
replace g11r3sm = 1 if hisboy11 == 1 | hisboy11new == 1
gen g12r3sm = 0
replace g12r3sm = 1 if hisboy12 == 1 | hisboy12new == 1
gen g9r3sf = 0
replace g9r3sf = 1 if hisgirl9 == 1 | hisgirl9new == 1
gen g10r3sf = 0
replace g10r3sf = 1 if hisgirl10 == 1 | hisgirl10new == 1
gen g11r3sf = 0
replace g11r3sf = 1 if hisgirl11 == 1 | hisgirl11new == 1
gen g12r3sf = 0
replace g12r3sf = 1 if hisgirl12 == 1 | hisgirl12new == 1

gen g9r4sm = 0
replace g9r4sm = 1 if asnboy9 == 1 | asnboy9new == 1
gen g10r4sm = 0
replace g10r4sm = 1 if asnboy10 == 1 | asnboy10new == 1
gen g11r4sm = 0
replace g11r4sm = 1 if asnboy11 == 1 | asnboy11new == 1
gen g12r4sm = 0
replace g12r4sm = 1 if asnboy12 == 1 | asnboy12new == 1
gen g9r4sf = 0
replace g9r4sf = 1 if asngirl9 == 1 | asngirl9new == 1
gen g10r4sf = 0
replace g10r4sf = 1 if asngirl10 == 1 | asngirl10new == 1
gen g11r4sf = 0
replace g11r4sf = 1 if asngirl11 == 1 | asngirl11new == 1
gen g12r4sf = 0
replace g12r4sf = 1 if asngirl12 == 1 | asngirl12new == 1
gen g9r5sm = 0
replace g9r5sm = 1 if otherboy9 == 1 | otherboy9new == 1
gen g10r5sm = 0
replace g10r5sm = 1 if otherboy10 == 1 | otherboy10new == 1
gen g11r5sm = 0
replace g11r5sm = 1 if otherboy11 == 1 | otherboy11new == 1
gen g12r5sm = 0
replace g12r5sm = 1 if otherboy12 == 1 | otherboy12new == 1
gen g9r5sf = 0
replace g9r5sf = 1 if othergirl9 == 1 | othergirl9new == 1
gen g10r5sf = 0
replace g10r5sf = 1 if othergirl10 == 1 | othergirl10new == 1
gen g11r5sf = 0
replace g11r5sf = 1 if othergirl11 == 1 | othergirl11new == 1
gen g12r5sf = 0
replace g12r5sf = 1 if othergirl12 == 1 | othergirl12new == 1

replace  date1stsex = 0 if date1stsex == .
replace  daterecsex = 0 if daterecsex == .
replace  timesincesex = 0 if timesincesex == .

egen SchID = group(scid)
*egen region = mode(aregion), by(scid)
la var region "1=west, 2=midwest, 3=south, 4=northeast"

gen S9 = hsg9r1sm + hsg9r1sf + hsg9r2sm + hsg9r2sf + hsg9r3sm + hsg9r3sf + hsg9r4sm + hsg9r4sf + hsg9r5sm + hsg9r5sf
gen S10 = hsg10r1sm + hsg10r1sf + hsg10r2sm + hsg10r2sf + hsg10r3sm + hsg10r3sf + hsg10r4sm + hsg10r4sf + hsg10r5sm + hsg10r5sf
gen S11 = hsg11r1sm + hsg11r1sf + hsg11r2sm + hsg11r2sf + hsg11r3sm + hsg11r3sf + hsg11r4sm + hsg11r4sf + hsg11r5sm + hsg11r5sf
gen S12 = hsg12r1sm + hsg12r1sf + hsg12r2sm+ hsg12r2sf + hsg12r3sm + hsg12r3sf + hsg12r4sm + hsg12r4sf + hsg12r5sm + hsg12r5sf

gen SS = S10 + S11 + S12


drop if grade < 9 | grade > 12
drop if grade == .
tab boys

joinby aid using /home/beauchaa/AddHealth/UsableData/w1weights.dta, unm(m) _merge(m3)
*drop if gswgt1 == .
replace race = 4 if race == 5

*Probability of being in a particular grade given age
gen probg9a1 = 422/1312
gen probg9a2 = 650/1312
gen probg9a3 = 164/1312
gen probg9a4 = 34/1312
gen probg9a5 = 4/1312
gen probg10a1 = 40/1419
gen probg10a2 = 580/1419
gen probg10a3 = 640/1419
gen probg10a4 = 122/1419
gen probg10a5 = 20/1419
gen probg11a1 = 7/1383
gen probg11a2 = 67/1383
gen probg11a3 = 607/1383
gen probg11a4 = 604/1383
gen probg11a5 = 84/1383
gen probg12a1 = 3/889
gen probg12a2 = 8/889
gen probg12a3 = 52/889
gen probg12a4 = 431/889
gen probg12a5 = 379/889
 
 
drop if scid==31|scid==39
tab boys

*gen byear = 1900+ h1gi1y if h1gi1y < 96
gen bmonth=h1gi1m if h1gi1m < 96
 
gen bdate = ym(byear,bmonth)
gen iiyear = iyear+1900
gen idate = ym(iiyear,imonth)
gen iage = idate - bdate
 

*********************************************************
*Objective Relationship Measures
*********************************************************
gen love1 = 0
replace love1 = 1 if h1ri21j1 == 1
gen love2 = 0
replace love2 = 1 if h1ri21j2 == 1
gen love3 = 0
replace love3 = 1 if h1ri21j3 == 1
gen love = 0 
replace love = 1 if h1lr3 ==1 | h1ri21j1 == 1 | h1ri21j2 == 1 | h1ri21j3 == 1   

gen kiss = 0
replace kiss = 1 if h1lr2 == 1 |  h1ri21m1 == 1 |  h1nr11_1 == 1 | h1rx21m1 == 1 |  h1ri21m2 == 1 |  h1nr11_2 == 1 | h1rx21m3 == 1 |  h1ri21m3 == 1 | h1nr11_3 == 1 | h1rx21m3 == 1 

gen holdhand = 0
replace holdhand = 1 if h1lr1 == 1 | h1ri21f1 == 1 | h1ri21f2 == 1 | h1ri21f3 == 1 | h1nr10_1 == 1 | h1rx21f1 == 1 | h1nr10_2 == 1 | h1rx21f2 == 1  | h1nr10_3 == 1 | h1rx21f3 == 1

gen rel1 = 0 
replace rel1 = 1 if ( h1lr2 == 1 & h1lr1 == 1 & h1lr4 == 1) | ( h1ri21m1 == 1 & h1ri21f1 == 1)
gen rel2 =0
replace rel2 = 1 if  (  h1ri21m2 == 1 &  h1ri21f2 == 1)
gen rel3 =0
replace rel3 = 1 if  ( h1ri21m3 == 1 &  h1ri21f3 == 1)

gen rel1nx =0
replace rel1nx = 1 if  (  h1rx21m1 == 1 &  h1rx21f1 == 1)
gen rel2nx =0
replace rel2nx = 1 if  (  h1rx21m2 == 1 &  h1rx21f2 == 1)
gen rel3nx =0
replace rel3nx = 1 if  (   h1rx21m3 == 1 &  h1rx21f3 == 1)

gen rel1nr =0
replace rel1nr = 1 if  (h1nr10_1 ==1 & h1nr11_1==1 )
gen rel2nr =0
replace rel2nr = 1 if  (h1nr10_2 ==1 & h1nr11_2==1 )
gen rel3nr = 0
replace rel3nr = 1 if  (h1nr10_3 ==1 & h1nr11_3==1 )

*********************************************************
*Same School Info
*********************************************************
gen sameschool1 = 0
replace sameschool1 = 1 if  h1ri14_1 == 1
gen sameschool2 = 0
replace sameschool2 = 1 if  h1ri14_2 == 1
gen sameschool3 = 0
replace sameschool3 = 1 if h1ri14_3 == 1

gen sameschool1nx = 0
replace sameschool1nx = 1 if  h1rx14_1 == 1  
gen sameschool2nx = 0
replace sameschool2nx = 1 if  h1rx14_2 == 1  
gen sameschool3nx = 0
replace sameschool3nx = 1 if h1rx14_3 == 1  

gen sameschool1nr = 0
replace sameschool1nr = 1 if  h1nr14_1 == 1  
gen sameschool2nr = 0
replace sameschool2nr = 1 if  h1nr14_2 == 1  
gen sameschool3nr = 0
replace sameschool3nr = 1 if h1nr14_3 == 1 

*********************************************************
*Current Status
*********************************************************
gen today = idate

gen date1end = ym(1900+h1ri11y1 , h1ri11m1 ) if h1ri11y1<96& h1ri11m1<96
gen date2end = ym(1900+h1ri11y2 , h1ri11m2 ) if h1ri11y2<96& h1ri11m2<96
gen date3end = ym(1900+h1ri11y3 , h1ri11m3 ) if h1ri11y3<96& h1ri11m3<96

gen date1nxend = ym(1900+h1rx11y1 , h1rx11m1 ) if h1rx11y1<96& h1rx11m1<96
gen date2nxend = ym(1900+h1rx11y2 , h1rx11m2 ) if h1rx11y2<96& h1rx11m2<96
gen date3nxend = ym(1900+h1rx11y3 , h1rx11m3 ) if h1rx11y3<96& h1rx11m3<96
  
gen date1nrend = ym(1900+h1nr24y1,h1nr24m1) if  h1nr24m1 < 13 & h1nr24y1 < 96
gen date2nrend = ym(1900+h1nr24y2,h1nr24m2) if  h1nr24m2 < 13 & h1nr24y2 < 96
gen date3nrend = ym(1900+h1nr24y3,h1nr24m3) if  h1nr24m3 < 13 & h1nr24y3 < 96

gen current1 = 0
replace current1 = 1 if h1ri10_1  == 1
gen current2 = 0
replace current2 = 1 if h1ri10_2  == 1 & h1ri10_1  == 0 & h1ri10_3  == 0
gen current3 = 0
replace current3 = 1 if h1ri10_3  == 1 & h1ri10_1  == 0 & h1ri10_2  == 0
replace current1 = (date1end >idate-3) if current1==0 &date1end < .
replace current2 = (date2end >idate-3) if current2==0&current1==0 &date2end < .
replace current3 = (date3end >idate-3) if current3==0&current1==0&current2==0 &date3end < .
replace current1 =1 if h1ri11m1==98|h1ri11y1==98
replace current2 =1 if h1ri11m2==98|h1ri11y2==98
replace current3 =1 if h1ri11m3==98|h1ri11y3==98


gen current1nr=0 if current1==0&current2==0&current3==0
gen current2nr=0 if current1==0&current2==0&current3==0
gen current3nr=0 if current1==0&current2==0&current3==0
replace current1nr = (date1nrend >idate-3) if current1nr==0&date1nrend < .
replace current2nr = (date2nrend >idate-3) if current1nr==0&date2nrend < .
replace current3nr = (date3nrend >idate-3) if  current2nr==0&current3nr==0 &date3nrend < .
replace current1nr =1 if h1nr24m1==98|h1nr24y1==98
replace current2nr =1 if h1nr24m2==98|h1nr24y2==98
replace current3nr =1 if h1nr24m3==98|h1nr24y3==98

gen current1nx = 0
replace current1nx = 1 if h1rx10_1  == 1  & (current1==0&current2==0&current3==0&current1nr==0&current2nr==0&current3nr==0) 
gen current2nx = 0
replace current2nx = 1 if (h1rx10_2  == 1 & h1rx10_1  == 0 & h1rx10_3  == 0 ) & (current1nx==0&current1==0&current2==0&current3==0&current1nr==0&current2nr==0&current3nr==0)
gen current3nx = 0
replace current3nx = 1 if (h1rx10_3  == 1 & h1rx10_1  == 0 & h1rx10_2  == 0 ) & (current1nx==0&current2nx==0&current1==0&current2==0&current3==0&current1nr==0&current2nr==0&current3nr==0)
replace current1nx = (date1nxend >idate-3) if current1nx==0 &date1nxend < .
replace current2nx = (date2nxend >idate-3) if current2nx==0&current1nx==0 &date2nxend < .
replace current3nx = (date3nxend >idate-3) if current3nx==0&current1nx==0&current2nx==0 &date3nxend < .
replace current1nx =1 if h1rx11m1==98|h1rx11y1==98
replace current2nx =1 if h1rx11m2==98|h1rx11y2==98
replace current3nx =1 if h1rx11m3==98|h1rx11y3==98

*********************************************************
*Recent sex status
*********************************************************
gen sexin1 = 0
replace sexin1 = 1 if h1ri21o1 == 1 
gen sexin2 = 0
replace sexin2 = 1 if h1ri21o2 == 1 
gen sexin3 = 0
replace sexin3 = 1 if h1ri21o3 == 1 

gen sexin1nx = 0
replace sexin1nx = 1 if h1rx21o1 == 1 
gen sexin2nx = 0
replace sexin2nx = 1 if h1rx21o2 == 1 
gen sexin3nx = 0
replace sexin3nx = 1 if h1rx21o3 == 1 

gen sexin1nr = 0
replace sexin1nr = 1 if h1nr22_1== 1 
gen sexin2nr = 0
replace sexin2nr = 1 if h1nr22_2 == 1 
gen sexin3nr = 0
replace sexin3nr = 1 if h1nr22_3 == 1 

gen upsexin1 = 0
replace upsexin1 = 1 if (h1ri28_1 == 0|h1ri31_1==0|h1ri32_1==0|h1ri36_1==0|h1ri37_1==0)  & h1ri21o1 == 1 
gen upsexin2 = 0
replace upsexin2 = 1 if (h1ri28_2 == 0|h1ri31_2==0|h1ri32_2==0|h1ri36_2==0|h1ri37_2==0)  & h1ri21o2 == 1 
gen upsexin3 = 0
replace upsexin3 = 1 if (h1ri28_3 == 0|h1ri31_3==0|h1ri32_3==0|h1ri36_3==0|h1ri37_3==0)   & h1ri21o3 == 1 

gen upsexin1nx = 0
replace upsexin1nx = 1 if (h1rx28_1 == 0|h1rx31_1==0|h1rx32_1==0|h1rx36_1==0|h1rx37_1==0) &  h1rx21o1 == 1
gen upsexin2nx = 0
replace upsexin2nx = 1 if  (h1rx28_2 == 0|h1rx31_2==0|h1rx32_2==0|h1rx36_2==0|h1rx37_2==0)  &  h1rx21o2 == 1
gen upsexin3nx = 0
replace upsexin3nx = 1 if  (h1rx28_2 == 0|h1rx31_2==0|h1rx32_2==0|h1rx36_2==0|h1rx37_2==0)   &  h1rx21o3 == 1

gen upsexin1nr = 0
replace upsexin1nr = 1 if ( h1nr26_1 == 0 | h1nr29_1==0 | h1nr30_1==0 | h1nr34_1==0 )&  h1nr22_1== 1 
gen upsexin2nr = 0
replace upsexin2nr = 1 if  ( h1nr26_2 == 0 | h1nr29_2==0 | h1nr30_2==0 | h1nr34_2==0 )&  h1nr22_2== 1 
gen upsexin3nr = 0
replace upsexin3nr = 1 if  ( h1nr26_3 == 0 | h1nr29_3==0 | h1nr30_3==0 | h1nr34_3==0 )&  h1nr22_3== 1 

*********************************************************
*Relationship Variables
*********************************************************
gen relcur = 0
replace relcur = 1 if current3 == 1 & rel3 == 1
replace relcur = 1 if current2 == 1 & rel2 == 1
replace relcur = 1 if current1 == 1 & rel1 == 1 
replace relcur = 1 if hadrellast1==1 &relcur==0

gen relcurnr = 0
replace relcurnr = 1 if current3nr == 1 & rel3nr == 1&relcur!=1
replace relcurnr = 1 if current2nr == 1 & rel2nr == 1&relcur!=1
replace relcurnr = 1 if current1nr == 1 & rel1nr == 1&relcur!=1

gen relcurnx = 0
replace relcurnx = 1 if current3nx == 1 & rel3nx == 1&relcur!=1
replace relcurnx = 1 if current2nx == 1 & rel2nx == 1&relcur!=1
replace relcurnx = 1 if current1nx == 1 & rel1nx == 1&relcur!=1
replace relcur = 1 if hadrellast1nx==1 &relcurnx==0&relcur!=1

gen relcurss = 0
replace relcurss = 1 if current3 == 1 & rel3 == 1 & sameschool3==1 
replace relcurss = 1 if current2 == 1 & rel2 == 1 & sameschool2==1 
replace relcurss = 1 if current1 == 1 & rel1 == 1 & sameschool1==1
replace relcurss = 1 if hadrellast1==1 &relcurss==0&sameschool3==1&mostrecrel==3
replace relcurss = 1 if hadrellast1==1 &relcurss==0&sameschool2==1&mostrecrel==2
replace relcurss = 1 if hadrellast1==1 &relcurss==0&sameschool1==1&mostrecrel==1

gen relcurnrss = 0
replace relcurnrss = 1 if current3nr == 1 & rel3nr == 1 & sameschool3nr==1&relcurss!=1
replace relcurnrss = 1 if current2nr == 1 & rel2nr == 1 & sameschool2nr==1&relcurss!=1 
replace relcurnrss = 1 if current1nr == 1 & rel1nr == 1 & sameschool1nr==1&relcurss!=1 
 
gen relcurnxss = 0
replace relcurnxss = 1 if current3nx == 1 & rel3nx == 1 & sameschool3nx==1&relcurss!=1 
replace relcurnxss = 1 if current2nx == 1 & rel2nx == 1 & sameschool2nx==1&relcurss!=1 
replace relcurnxss = 1 if current1nx == 1 & rel1nx == 1 & sameschool1nx==1&relcurss!=1 
replace relcurss = 1 if hadrellast1nx==1&relcurnxss==0&sameschool3==1&mostrecrelnx==3&relcurss!=1 
replace relcurss = 1 if hadrellast1nx==1&relcurnxss==0&sameschool2==1&mostrecrelnx==2&relcurss!=1 
replace relcurss = 1 if hadrellast1nx==1&relcurnxss==0&sameschool1==1&mostrecrelnx==1&relcurss!=1 


*********************************************************
*Sex Variables
*********************************************************
gen sexcur = 0 
replace sexcur = sexin3 if current3 == 1
replace sexcur = sexin2 if current2 == 1
replace sexcur = sexin1 if current1 == 1
replace sexcur =1 if hadsexlast1 == 1 & sexcur==0

gen sexcurnr = 0
replace sexcurnr = sexin3nr if current3nr == 1&sexcur!=1
replace sexcurnr = sexin2nr if current2nr == 1&sexcur!=1
replace sexcurnr = sexin1nr if current1nr == 1&sexcur!=1

gen sexcurnx = 0
replace sexcurnx = sexin3nx if current3nx == 1&sexcur!=1&sexcurnr!=1
replace sexcurnx = sexin2nx if current2nx == 1&sexcur!=1&sexcurnr!=1
replace sexcurnx = sexin1nx if current1nx == 1&sexcur!=1&sexcurnr!=1
replace sexcurnx =1 if hadsexlast1nx == 1&sexcurnx==0&sexcur!=1&sexcurnr!=1

gen sexcurss = 0 
replace sexcurss = sexin3 if  current3 == 1 & sameschool3==1
replace sexcurss = sexin2 if  current2 == 1 & sameschool2==1
replace sexcurss = sexin1 if  current1 == 1 & sameschool1==1
replace sexcurss = 1 if hadsexlast1==1 &sexcurss==0&sameschool3==1&mostrecrel==3  
replace sexcurss = 1 if hadsexlast1==1 &sexcurss==0&sameschool2==1&mostrecrel==2  
replace sexcurss = 1 if hadsexlast1==1 &sexcurss==0&sameschool1==1&mostrecrel==1  

gen sexcurnrss = 0
replace sexcurnrss = sexin3nr if  current3nr == 1 & sameschool3nr==1&sexcurss!=1
replace sexcurnrss = sexin2nr if  current2nr == 1 & sameschool2nr==1&sexcurss!=1
replace sexcurnrss = sexin1nr if  current1nr == 1 & sameschool1nr==1&sexcurss!=1

gen sexcurnxss = 0
replace sexcurnxss = sexin3nx if  current3nx == 1 & sameschool3nx==1&sexcurss!=1&sexcurnrss!=1
replace sexcurnxss = sexin2nx if  current2nx == 1 & sameschool2nx==1&sexcurss!=1&sexcurnrss!=1
replace sexcurnxss = sexin1nx if  current1nx == 1 & sameschool1nx==1&sexcurss!=1&sexcurnrss!=1
replace sexcurnxss = 1 if hadsexlast1nx==1 &sexcurnxss==0&sameschool3nx==1&mostrecrelnx==3 &sexcurss!=1
replace sexcurnxss = 1 if hadsexlast1nx==1 &sexcurnxss==0&sameschool2nx==1&mostrecrelnx==2 &sexcurss!=1
replace sexcurnxss = 1 if hadsexlast1nx==1 &sexcurnxss==0&sameschool1nx==1&mostrecrelnx==1 &sexcurss!=1


gen upsexcur = 0 
replace upsexcur = upsexin3 if current3 == 1
replace upsexcur = upsexin2 if current2 == 1
replace upsexcur = upsexin1 if current1 == 1
replace upsexcur = 1 if hadsexlast1 == 1 & h1co6 == 0

gen upsexcurnr = 0
replace upsexcurnr = upsexin3nr if current3nr == 1&upsexcur!=1
replace upsexcurnr = upsexin2nr if current2nr == 1&upsexcur!=1
replace upsexcurnr = upsexin1nr if current1nr == 1&upsexcur!=1

gen upsexcurnx = 0
replace upsexcurnx = upsexin3nx if current3nx == 1&upsexcur!=1
replace upsexcurnx = upsexin2nx if current2nx == 1&upsexcur!=11
replace upsexcurnx = upsexin1nx if current1nx == 1&upsexcur!=1
 
gen upsexcurss = 0 
replace upsexcurss = upsexin3 if  current3 == 1 & sameschool3==1
replace upsexcurss = upsexin2 if  current2 == 1 & sameschool2==1
replace upsexcurss = upsexin1 if  current1 == 1 & sameschool1==1
replace upsexcurss = 1 if hadsexlast1==1& h1co6 == 0 &upsexcurss==0&sameschool3==1&mostrecrel==3  
replace upsexcurss = 1 if hadsexlast1==1& h1co6 == 0 &upsexcurss==0&sameschool2==1&mostrecrel==2  
replace upsexcurss = 1 if hadsexlast1==1& h1co6 == 0 &upsexcurss==0&sameschool1==1&mostrecrel==1  

gen upsexcurnrss = 0
replace upsexcurnrss = upsexin3nr if  current3nr == 1 & sameschool3nr==1&sexcurss!=1
replace upsexcurnrss = upsexin2nr if  current2nr == 1 & sameschool2nr==1&sexcurss!=1
replace upsexcurnrss = upsexin1nr if  current1nr == 1 & sameschool1nr==1&sexcurss!=1

gen upsexcurnxss = 0
replace upsexcurnxss = upsexin3nx if  current3nx == 1 & sameschool3nx==1&upsexcurss!=1&upsexcurnrss!=1
replace upsexcurnxss = upsexin2nx if  current2nx == 1 & sameschool2nx==1&upsexcurss!=1&upsexcurnrss!=1
replace upsexcurnxss = upsexin1nx if  current1nx == 1 & sameschool1nx==1&upsexcurss!=1&upsexcurnrss!=1
replace upsexcurnxss = 1 if hadsexlast1nx==1& h1co6 == 0 &upsexcurnxss==0&sameschool3nx==1&mostrecrelnx==3 &upsexcurss!=1
replace upsexcurnxss = 1 if hadsexlast1nx==1& h1co6 == 0 &upsexcurnxss==0&sameschool2nx==1&mostrecrelnx==2 &upsexcurss!=1
replace upsexcurnxss = 1 if hadsexlast1nx==1& h1co6 == 0 &upsexcurnxss==0&sameschool1nx==1&mostrecrelnx==1 &upsexcurss!=1


***********************************************************
*FINAL SEX VARIALBES
***********************************************************
gen relcurall  = (relcur==1|relcurnr==1|relcurnx==1)
gen relcurallss  = (relcurss==1|relcurnrss==1|relcurnxss==1)
gen sexcurall  = (sexcur==1|sexcurnr==1|sexcurnx==1)
gen sexcurallss  = (sexcurss==1|sexcurnrss==1|sexcurnxss==1)
gen upsexcurall  = (upsexcur==1|upsexcurnr==1|upsexcurnx==1)
gen upsexcurallss  = (upsexcurss==1|upsexcurnrss==1|upsexcurnxss==1)


*********************************************************
*Generating Relationship Timing
*********************************************************
*BEGINNING DATE
gen yearrelcur = .
replace yearrelcur = 1900 +  h1ri1y_1 if  h1ri1y_1 < 96 &  h1ri1y_1 > 0 & current1 == 1
replace yearrelcur = 1900 +  h1ri1y_2 if  h1ri1y_2 < 96 &  h1ri1y_2 > 0 & current2 == 1&current1==0
replace yearrelcur = 1900 +  h1ri1y_3 if  h1ri1y_3 < 96 &  h1ri1y_3 > 0 & current3 == 1&current1==0&current2==0

replace yearrelcur = 1900 +  h1rx1y_1 if  h1rx1y_1 < 96 &  h1rx1y_1 > 0 & (current1 == 0&current2==0&current3==0)&current1nx==1
replace yearrelcur = 1900 +  h1rx1y_2 if  h1rx1y_2 < 96 &  h1rx1y_2 > 0 & (current1 == 0&current2==0&current3==0)&current1nx==0&current2nx==1
replace yearrelcur = 1900 +  h1rx1y_3 if  h1rx1y_3 < 96 &  h1rx1y_3 > 0 & (current1 == 0&current2==0&current3==0)&current1nx==0&current2nx==0&current3nx == 1


drop day
gen day = 1  
gen morelcur = .
replace morelcur = h1ri1m_1 if h1ri1m_1 < 96 & h1ri1m_1 > 0 & current1 == 1
replace morelcur = h1ri1m_2 if h1ri1m_2 < 96 & h1ri1m_2 > 0 & current2 == 1&current1==0
replace morelcur = h1ri1m_3 if h1ri1m_3 < 96 & h1ri1m_3 > 0 & current3 == 1&current1==0&current2==0

replace morelcur = h1rx1m_1 if  h1rx1m_1 < 96 &  h1rx1m_1 > 0 & (current1 == 0&current2==0&current3==0)&current1nx==1
replace morelcur = h1rx1m_2 if  h1rx1m_2 < 96 &  h1rx1m_2 > 0 & (current1 == 0&current2==0&current3==0)&current1nx==0&current2nx==1
replace morelcur = h1rx1m_3 if  h1rx1m_3 < 96 &  h1rx1m_3 > 0 & (current1 == 0&current2==0&current3==0)&current1nx==0&current2nx==0&current3nx == 1

gen daterelcur =  mdy(morelcur, day, yearrelcur) 
format daterelcur %d

*recoding date of 1st sex
replace date1stsex = . if date1stsex == 0

gen sexprior = (date1stsex < daterelcur) if (date1stsex< . &daterelcur<.)
replace sexprior = 1 if h1co1==1&sexprior==.
replace sexprior = 0 if h1co1==0&sexprior==.

gen daterel1 = ym(1900+h1ri1y_1,h1ri1m_1) if h1ri1y_1<96 &h1ri1m_1<96
gen sexin1new = (h1ri24a1==1)
replace sexin1 = sexin1new
gen datesex1 = ym( 1900+h1ri25y1, h1ri25m1 ) if h1ri25y1<96& h1ri25m1<96
gen datefirstsex = ym(1900+ h1co2y, h1co2m ) if h1co2m<96 & h1co2y<96

gen priorsex1 = (datefirstsex<datesex1) if datefirstsex<.&datesex1<.&(sexin1new==1)
replace priorsex1 = (datefirstsex<daterel1) if datefirstsex<.&daterel1<.&(rel1==1&sexin1new==0)
replace priorsex1 = 0 if daterel1 < datefirstsex
replace priorsex1 = 0 if hadsex==0&priorsex1==.
 

*Date of Recent Sex Inside each relationship
gen yearsexcur = .
replace yearsexcur = 1900 + h1ri25y1 if h1ri25y1 < 96 &  h1ri25y1 > 0 & current1 == 1  
replace yearsexcur = 1900 + h1ri25y2 if h1ri25y2 < 96 &  h1ri25y2 > 0 & current2 == 1  
replace yearsexcur = 1900 + h1ri25y3 if h1ri25y3 < 96 &  h1ri25y3 > 0 & current3 == 1  
gen mosexcur = .
replace mosexcur = h1ri25m1 if h1ri25m1 < 96 & h1ri25m1 > 0 & current1 == 1  
replace mosexcur = h1ri25m2 if h1ri25m2 < 96 & h1ri25m2 > 0 & current2 == 1  
replace mosexcur = h1ri25m3 if h1ri25m3 < 96 & h1ri25m3 > 0 & current3 == 1  
gen datesexcur =  mdy(mosexcur, day, yearsexcur) 
replace datesexcur = 0 if relcur == 1 & datesexcur == .
format datesexcur %d

replace daterecsex = . if daterecsex == 0
gen ttsexrelcur = datesexcur - daterelcur if datesexcur > daterelcur 

gen timeincurrel = dateInt - daterelcur



***********************************************
*Other information
**********************************************
egen hssize = mode(HSsize),min by(scid) 
replace hssize = n_roster if hssize == .

*gen int9 = GR9th*S9
*gen int10 = GR10th*S10
*gen int11 = GR11th*S11
*gen int12 = GR12th*S12

gen match = 1 if (sexcur == 1 | relcur == 1)
replace match = 0 if match == .
 
gen matchss = 1 if (sexcurss == 1 | relcurss == 1)
replace matchss =0 if matchss ==.

gen sub = 0
replace sub =1 if metro == 2
 
gen drop12 = a18f if a18f < 100
gen drop11 = a18e if a18e < 100
gen drop10 = a18d if a18d < 100
gen drop9 = a18c if a18c < 100
egen idrop12 = mode(drop12), by(scid) min
egen idrop11 = mode(drop11), by(scid) min
egen idrop10 = mode(drop10), by(scid) min
egen idrop9 = mode(drop9), by(scid) min
gen hsdrop = (idrop12 + idrop11 + idrop10)/300


gen numsexrels = (sexin1==1) + (sexin2==1) + (sexin3==1) + 0
gen numsexrelstot = 0 + (sexin1==1) + (sexin2==1) + (sexin3==1) + (sexin1nr==1) + (sexin2nr==1) + (sexin3nr==1) 
gen numpastsexrels = (sexin1==1)*(current1==0) + (sexin2==1)*(current2==0) + (sexin3==1)*(current3==0)

gen std = 0
replace std = 1 if h1co16a ==1|h1co16b==1| h1co16c==1| h1co16e==1| h1co16d==1| h1co16f==1| h1co16g==1| h1co16h==1| h1co16i==1| h1co16j==1



gen lnsr = log(1+numsexrels)
gen lnsrtot = log(1+numsexrelstot)


*Physical Descriptives
gen looks = h1ir1 - 1 if h1ir1 < 6
replace looks = 1 if looks == 0

gen aboveavg = (looks>3) if looks < .


gen height = h1gh59a*12 + h1gh59b if h1gh59a < 13 & h1gh59b< 13
gen weight = h1gh60 if h1gh60<500
gen hweight=weight/height
gen hweight2=hweight^2
gen height2=height*height
gen shortman=height<65
gen tallwoman=height>70
gen bmi = (weight/height2)*703


*State Preferences
gen wanttouch =  1 if h1id1n == 1
replace wanttouch = 0 if h1id1n == 2
gen wanttalkbc =  1 if h1id1l == 1
replace wanttalkbc = 0 if h1id1l == 2
gen wantsex =  1 if h1id1o == 1
replace wantsex = 0 if h1id1o == 2
gen wantrel = 0
replace wantrel = 1 if h1id1f == 1  & h1id1m == 1

*old love-based definition
*replace wantrel = 1 if h1id1f == 1 & h1id1i == 1 & h1id1m == 1
*replace wantrel = 0 if h1id1f == 2 | h1id1i == 2 | h1id1m == 2
gen wantcouple =  1 if h1id1c == 1
replace wantcouple = 0 if h1id1c == 2

/*
*Popularity Variables
gen nfemnoms = axrs2*nars2
gen nmalnoms = (1-axrs2)*nars2 

gen noppsexnoms = nfemnoms*(boys==1) + nmalnoms*(girls==1)

gen propnomsbyoppsex = axrs2*(boys) + (1-axrs2)*girls
gen propnomsbysamesex = axrs2*(girls) + (1-axrs2)*boys
gen propfribyoppsex = axss2*(boys) + (1-axss2)*girls
gen propfribysamesex = axss2*(girls) + (1-axss2)*boys
*/
gen virgpledge = h1id5 if h1id5 < 6

*Student Behaviors
gen smokefreq = s59a if s59a < 99
gen smoker = (smokefreq>0)
gen drunkfreq = s59c if s59c < 99
gen skipfreq = s59g if s59g < 99
gen wantcol = h1ee1 if h1ee1 < 6
gen thinkcol = h1ee2 if h1ee2 < 6
gen faminc = pa55 if pa55 < 9996
gen sports = 1 if s44a18==1| s44a19==1| s44a20==1| s44a21==1| s44a22==1| s44a23==1| s44a24==1| s44a25==1| s44a26==1| s44a28==1| s44a27==1
replace sports = 0 if sports == .

*Parent Information
gen parhap = pb18 if pb18 < 96 
gen pareduc = pa12 if pa12 < 10

*Sex Outcomes
gen get = 1*( relcur==1&sexcur==0) + 2*(relcur==1&sexcur==1) + 3*(relcur==0&sexcur==1)
gen want = 1*(wantrel==1&wantsex==0) + 2*(wantrel==1&wantsex==1) + 3*(wantrel==0&wantsex==1)
gen want1 = (relcur==1&sexcur==0)
gen want2 = (relcur==1&sexcur==1)
gen want3 = (relcur==0&sexcur==1)
gen wantit = want1*(get==1) + want2*(get==2) + want3*(get==3)
gen getwhatwant = 1 if want==get & want > 0&get > 0
replace getwhatwant = 0 if getwhatwant == .
***********************************************************
*Combining GPA Data
***********************************************************
gen gpa_l = (gpa_low==1|gpa_low_inhome==1) if (gpa_low_inhome<.|gpa_low<.)
gen gpa_m = (gpa_med==1|gpa_med_inhome==1) if (gpa_med_inhome<.|gpa_med<.)
gen gpa_h = (gpa_hi==1|gpa_hi_inhome==1) if (gpa_hi_inhome<.|gpa_hi<.)

gen gpa_me_l = (gpa_low_ME==1|gpa_low_inhome_ME==1) if (gpa_low_inhome_ME<.|gpa_low_ME<.)
gen gpa_me_m = (gpa_med_ME==1|gpa_med_inhome_ME==1) if (gpa_med_inhome_ME<.|gpa_med_ME<.)
gen gpa_me_h = (gpa_hi_ME==1|gpa_hi_inhome_ME==1) if (gpa_hi_inhome_ME<.|gpa_hi_ME<.)




*Partner Grades
gen partgrade1 = 0
gen partgrade2 = 0
gen partgrade3 = 0
gen partgrade1nr = 0
gen partgrade2nr = 0
gen partgrade3nr = 0


*Matching with 7th 8th graders viewed as failed HS match
 replace partgrade1   = -1 if h1ri15_1 <9
 replace partgrade1nr = -1 if h1rx15_1 <9 
 replace partgrade2   = -1 if h1ri15_2 <9 
 replace partgrade2nr = -1 if h1rx15_2 <9 
 replace partgrade3   = -1 if h1ri15_3 <9 
 replace partgrade3nr = -1 if h1rx15_3 <9 
*replace partgrade1 = 0 if h1ri15_1 == 7 
*replace partgrade1 = 0 if h1ri15_1 == 8 
*replace partgrade2 = 0 if h1ri15_2 == 7 
*replace partgrade2 = 0 if h1ri15_2 == 8 
*replace partgrade3 = 0 if h1ri15_3 == 7 
*replace partgrade3 = 0 if h1ri15_3 == 8 

**********************************************
*Partner Grades
**********************************************
replace partgrade1 = 1 if h1ri15_1 == 9 
replace partgrade1 = 2 if h1ri15_1 == 10 
replace partgrade1 = 3 if h1ri15_1 == 11 
replace partgrade1 = 4 if h1ri15_1 == 12 
replace partgrade1 = 5 if h1ri15_1 == 13 | h1ri15_1 == 14

replace partgrade2 = 1 if h1ri15_2 == 9 
replace partgrade2 = 2 if h1ri15_2 == 10 
replace partgrade2 = 3 if h1ri15_2 == 11 
replace partgrade2 = 4 if h1ri15_2 == 12 
replace partgrade2 = 5 if h1ri15_2 == 13 | h1ri15_2 == 14

replace partgrade3 = 1 if h1ri15_3 == 9 
replace partgrade3 = 2 if h1ri15_3 == 10 
replace partgrade3 = 3 if h1ri15_3 == 11 
replace partgrade3 = 4 if h1ri15_3 == 12 
replace partgrade3 = 5 if h1ri15_3 == 13 | h1ri15_3 == 14

*********************************************
*Partner Grades-Non Romantic
*********************************************
replace partgrade1nr = 1 if h1rx15_1 == 9 
replace partgrade1nr = 2 if h1rx15_1 == 10 
replace partgrade1nr = 3 if h1rx15_1 == 11 
replace partgrade1nr = 4 if h1rx15_1 == 12 
replace partgrade1nr = 5 if h1rx15_1 == 13 | h1rx15_1 == 14

replace partgrade2nr = 1 if h1rx15_2 == 9 
replace partgrade2nr = 2 if h1rx15_2 == 10 
replace partgrade2nr = 3 if h1rx15_2 == 11 
replace partgrade2nr = 4 if h1rx15_2 == 12 
replace partgrade2nr = 5 if h1rx15_2 == 13 | h1rx15_2 == 14

replace partgrade3nr = 1 if h1rx15_3 == 9 
replace partgrade3nr = 2 if h1rx15_3 == 10 
replace partgrade3nr = 3 if h1rx15_3 == 11 
replace partgrade3nr = 4 if h1rx15_3 == 12 
replace partgrade3nr = 5 if h1rx15_3 == 13 | h1rx15_3 == 14

*Partner Ages
gen partage1 = 0
gen partage2 = 0
gen partage3 = 0
gen partage1nr = 0
gen partage2nr = 0
gen partage3nr = 0

*Matching with 7th 8th agers viewed as failed HS match
replace partage1 = 0 if h1ri15_1 == 7 
replace partage1 = 0 if h1ri15_1 == 8 
replace partage2 = 0 if h1ri15_2 == 7 
replace partage2 = 0 if h1ri15_2 == 8 
replace partage3 = 0 if h1ri15_3 == 7 
replace partage3 = 0 if h1ri15_3 == 8 

*Partner Ages
**********************************************
replace partage1 = 1 if h1ri3_1 == 14 
replace partage1 = 2 if h1ri3_1 == 15 
replace partage1 = 3 if h1ri3_1 == 16 
replace partage1 = 4 if h1ri3_1 == 17
replace partage1 = 5 if h1ri3_1 > 17 & h1ri3_1 < 20

replace partage2 = 1 if h1ri3_2 == 14 
replace partage2 = 2 if h1ri3_2 == 15 
replace partage2 = 3 if h1ri3_2 == 16 
replace partage2 = 4 if h1ri3_2 == 17
replace partage2 = 5 if h1ri3_2 > 17 & h1ri3_2 < 20

replace partage3 = 1 if h1ri3_3 == 14 
replace partage3 = 2 if h1ri3_3 == 15 
replace partage3 = 3 if h1ri3_3 == 16 

replace partage3 = 4 if h1ri3_3 == 17
replace partage3 = 5 if h1ri3_3 > 17 & h1ri3_3 < 20

*Partner Ages-Non Romantic
*********************************************
replace partage1nr = 1 if h1rx3_1 == 14 | h1nr13_1 == 14
replace partage1nr = 2 if h1rx3_1 == 15 | h1nr13_1 == 15
replace partage1nr = 3 if h1rx3_1 == 16 | h1nr13_1 == 16
replace partage1nr = 4 if h1rx3_1 == 17 | h1nr13_1 == 17
replace partage1nr = 5 if (h1rx3_1 > 17 & h1rx3_1 < 20) | (h1nr13_1 > 17 & h1nr13_1 < 20) 

replace partage2nr = 1 if h1rx3_2 == 14 | h1nr13_2 == 14
replace partage2nr = 2 if h1rx3_2 == 15 | h1nr13_2 == 15
replace partage2nr = 3 if h1rx3_2 == 16 | h1nr13_2 == 16
replace partage2nr = 4 if h1rx3_2 == 17 | h1nr13_2 == 17
replace partage2nr = 5 if (h1rx3_2 > 17 & h1rx3_2 < 20) | (h1nr13_2 > 17 & h1nr13_2 < 20) 

replace partage3nr = 1 if h1rx3_3 == 14 | h1nr13_3 == 14
replace partage3nr = 2 if h1rx4_3 == 15 | h1nr13_3 == 15
replace partage3nr = 3 if h1rx4_3 == 16 | h1nr13_3 == 16
replace partage3nr = 4 if h1rx4_3 == 17 | h1nr13_3 == 17
replace partage3nr = 5 if (h1rx4_3 > 17 & h1rx3_3 < 20) | (h1nr13_3 > 17 & h1nr13_3 < 20) 


egen girlinsex = mean(girls==1) if sexin1==1, by(scid)
egen girlinrel = mean(girls==1) if sexin1==0&rel1==1, by(scid)
 

*Summary Statistics show differences in reporting
gen hadsexnrlast2y = 0
replace hadsexnrlast2y = 1 if  h1nr8  > 0 & h1nr8 < 556
sum hadsexnrlast2y if hadrellast18 == 0 &  boys == 1
sum hadsexnrlast2y if hadrellast18 == 0 &  boys == 0
sum hadrellast18 if girls == 1
sum hadrellast18 if girls == 0

egen SSsample = total(SchID==SchID), by(SchID)

drop if SSsample < 10
tab boys

sort SchID
drop if grade == .
*drop if gswgt == .
egen sid = group(SchID)
sort sid
by sid: gen m9 =hsg9r1sm+hsg9r3sm+hsg9r2sm+hsg9r4sm 

by sid: gen m10 =hsg10r3sm+hsg10r1sm+hsg10r2sm+hsg10r4sm 
by sid: gen m11 =hsg11r3sm+hsg11r1sm+hsg11r2sm+hsg11r4sm  
by sid: gen m12 = hsg12r3sm+hsg12r1sm+hsg12r2sm+hsg12r4sm

by sid: gen f9 =hsg9r1sf+hsg9r3sf+hsg9r2sf+hsg9r4sf 
by sid: gen f10 =hsg10r3sf+hsg10r1sf+hsg10r2sf+hsg10r4sf 
by sid: gen f11 =hsg11r3sf+hsg11r1sf+hsg11r2sf+hsg11r4sf  
by sid: gen f12 = hsg12r3sf+hsg12r1sf+hsg12r2sf+hsg12r4sf

by sid: gen m9r1 =hsg9r1sm
by sid: gen m9r2 =hsg9r3sm
by sid: gen m9r3 =hsg9r2sm
by sid: gen m9r4= hsg9r4sm+hsg9r5sm
 
by sid: gen m10r1 =hsg10r1sm
by sid: gen m10r2 =hsg10r3sm
by sid: gen m10r3 =hsg10r2sm
by sid: gen m10r4= hsg10r4sm+hsg10r5sm

by sid: gen m11r1 =hsg11r1sm
by sid: gen m11r2 =hsg11r3sm
by sid: gen m11r3 =hsg11r2sm
by sid: gen m11r4= hsg11r4sm+hsg11r5sm

by sid: gen m12r1 =hsg12r1sm
by sid: gen m12r2 =hsg12r3sm
by sid: gen m12r3 =hsg12r2sm
by sid: gen m12r4= hsg12r4sm+hsg12r5sm

by sid: gen f9r1 =hsg9r1sf
by sid: gen f9r2 =hsg9r3sf
by sid: gen f9r3 =hsg9r2sf
by sid: gen f9r4= hsg9r4sf+hsg9r5sf
 
by sid: gen f10r1 =hsg10r1sf
by sid: gen f10r2 =hsg10r3sf
by sid: gen f10r3 =hsg10r2sf
by sid: gen f10r4= hsg10r4sf+hsg10r5sf

by sid: gen f11r1 =hsg11r1sf
by sid: gen f11r2 =hsg11r3sf
by sid: gen f11r3 =hsg11r2sf
by sid: gen f11r4= hsg11r4sf+hsg11r5sf

by sid: gen f12r1 =hsg12r1sf
by sid: gen f12r2 =hsg12r3sf
by sid: gen f12r3 =hsg12r2sf
by sid: gen f12r4= hsg12r4sf+hsg12r5sf


gen out = (sid == 31 | sid == 59 | sid==71 | sid==74 |sid == 73 | sid == 75)
drop if sid == 31 | sid == 59 | sid==71 | sid==74 |sid == 73 | sid == 75 
tab boys

egen sharesexm9r1 = mean(sexprior) if grade==9&boys==1&race==1, by(sid)
egen ssexm9r1 = min(sharesexm9r1), by(sid)
replace ssexm9r1=.5 if ssexm9r1==.
egen sharesexm10r1 = mean(sexprior) if grade==10&boys==1&race==1, by(sid)
egen ssexm10r1 = min(sharesexm10r1), by(sid)
replace ssexm10r1=.5 if ssexm10r1==.
egen sharesexm11r1 = mean(sexprior) if grade==11&boys==1&race==1, by(sid)
egen ssexm11r1 = min(sharesexm11r1), by(sid)
replace ssexm11r1=.5 if ssexm11r1==.
egen sharesexm12r1 = mean(sexprior) if grade==12&boys==1&race==1, by(sid)
egen ssexm12r1 = min(sharesexm12r1), by(sid)
replace ssexm12r1=.5 if ssexm12r1==.

egen sharesexm9r2 = mean(sexprior) if grade==9&boys==1&race==2, by(sid)
egen ssexm9r2 = min(sharesexm9r2), by(sid)
replace ssexm9r2=.5 if ssexm9r2==.
egen sharesexm10r2 = mean(sexprior) if grade==10&boys==1&race==2, by(sid)
egen ssexm10r2 = min(sharesexm10r2), by(sid)
replace ssexm10r2=.5 if ssexm10r2==.
egen sharesexm11r2 = mean(sexprior) if grade==11&boys==1&race==2, by(sid)
egen ssexm11r2 = min(sharesexm11r2), by(sid)
replace ssexm11r2=.5 if ssexm11r2==.
egen sharesexm12r2 = mean(sexprior) if grade==12&boys==1&race==2, by(sid)
egen ssexm12r2 = min(sharesexm12r2), by(sid)
replace ssexm12r2=.5 if ssexm12r2==.
 
egen sharesexm9r3 = mean(sexprior) if grade==9&boys==1&race==3, by(sid)
egen ssexm9r3 = min(sharesexm9r3), by(sid)
replace ssexm9r3=.5 if ssexm9r3==.
egen sharesexm10r3 = mean(sexprior) if grade==10&boys==1&race==3, by(sid)
egen ssexm10r3 = min(sharesexm10r3), by(sid)
replace ssexm10r3=.5 if ssexm10r3==.
egen sharesexm11r3 = mean(sexprior) if grade==11&boys==1&race==3, by(sid)
egen ssexm11r3 = min(sharesexm11r3), by(sid)
replace ssexm11r3=.5 if ssexm11r3==.
egen sharesexm12r3 = mean(sexprior) if grade==12&boys==1&race==3, by(sid)
egen ssexm12r3 = min(sharesexm12r3), by(sid)
replace ssexm12r3=.5 if ssexm12r3==.

egen sharesexm9r4 = mean(sexprior) if grade==9&boys==1&(race==4|race==5), by(sid)
egen ssexm9r4 = min(sharesexm9r4), by(sid)
replace ssexm9r4=.5 if ssexm9r4==.
egen sharesexm10r4 = mean(sexprior) if grade==10&boys==1&(race==4|race==5), by(sid)
egen ssexm10r4 = min(sharesexm10r4), by(sid)
replace ssexm10r4=.5 if ssexm10r4==.
egen sharesexm11r4 = mean(sexprior) if grade==11&boys==1&(race==4|race==5), by(sid)
egen ssexm11r4 = min(sharesexm11r4), by(sid)
replace ssexm11r4=.5 if ssexm11r4==.
egen sharesexm12r4 = mean(sexprior) if grade==12&boys==1&(race==4|race==5), by(sid)
egen ssexm12r4 = min(sharesexm12r4), by(sid)
replace ssexm12r4=.5 if ssexm12r4==.

egen sharesexf9r1 = mean(sexprior) if grade==9&boys==0&race==1, by(sid)
egen ssexf9r1 = min(sharesexf9r1), by(sid)
replace ssexf9r1=.5 if ssexf9r1==.
egen sharesexf10r1 = mean(sexprior) if grade==10&boys==0&race==1, by(sid)
egen ssexf10r1 = min(sharesexf10r1), by(sid)
replace ssexf10r1=.5 if ssexf10r1==.
egen sharesexf11r1 = mean(sexprior) if grade==11&boys==0&race==1, by(sid)
egen ssexf11r1 = min(sharesexf11r1), by(sid)
replace ssexf11r1=.5 if ssexf11r1==.
egen sharesexf12r1 = mean(sexprior) if grade==12&boys==0&race==1, by(sid)
egen ssexf12r1 = min(sharesexf12r1), by(sid)
replace ssexf12r1=.5 if ssexf12r1==.

egen sharesexf9r2 = mean(sexprior) if grade==9&boys==0&race==2, by(sid)
egen ssexf9r2 = min(sharesexf9r2), by(sid)
replace ssexf9r2=.5 if ssexf9r2==.
egen sharesexf10r2 = mean(sexprior) if grade==10&boys==0&race==2, by(sid)
egen ssexf10r2 = min(sharesexf10r2), by(sid)
replace ssexf10r2=.5 if ssexf10r2==.
egen sharesexf11r2 = mean(sexprior) if grade==11&boys==0&race==2, by(sid)
egen ssexf11r2 = min(sharesexf11r2), by(sid)
replace ssexf11r2=.5 if ssexf11r2==.
egen sharesexf12r2 = mean(sexprior) if grade==12&boys==0&race==2, by(sid)
egen ssexf12r2 = min(sharesexf12r2), by(sid)
replace ssexf12r2=.5 if ssexf12r2==.
 
egen sharesexf9r3 = mean(sexprior) if grade==9&boys==0&race==3, by(sid)
egen ssexf9r3 = min(sharesexf9r3), by(sid)
replace ssexf9r3=.5 if ssexf9r3==.
egen sharesexf10r3 = mean(sexprior) if grade==10&boys==0&race==3, by(sid)
egen ssexf10r3 = min(sharesexf10r3), by(sid)
replace ssexf10r3=.5 if ssexf10r3==.
egen sharesexf11r3 = mean(sexprior) if grade==11&boys==0&race==3, by(sid)
egen ssexf11r3 = min(sharesexf11r3), by(sid)
replace ssexf11r3=.5 if ssexf11r3==.
egen sharesexf12r3 = mean(sexprior) if grade==12&boys==0&race==3, by(sid)
egen ssexf12r3 = min(sharesexf12r3), by(sid)
replace ssexf12r3=.5 if ssexf12r3==.

egen sharesexf9r4 = mean(sexprior) if grade==9&boys==0&(race==4|race==5), by(sid)
egen ssexf9r4 = min(sharesexf9r4), by(sid)
replace ssexf9r4=.5 if ssexf9r4==.
egen sharesexf10r4 = mean(sexprior) if grade==10&boys==0&(race==4|race==5), by(sid)
egen ssexf10r4 = min(sharesexf10r4), by(sid)
replace ssexf10r4=.5 if ssexf10r4==.
egen sharesexf11r4 = mean(sexprior) if grade==11&boys==0&(race==4|race==5), by(sid)
egen ssexf11r4 = min(sharesexf11r4), by(sid)
replace ssexf11r4=.5 if ssexf11r4==.
egen sharesexf12r4 = mean(sexprior) if grade==12&boys==0&(race==4|race==5), by(sid)
egen ssexf12r4 = min(sharesexf12r4), by(sid)
replace ssexf12r4=.5 if ssexf12r4==.


gen hsm9r1 = round(ssexm9r1*m9r1)
gen nhsm9r1 = m9r1 - hsm9r1
gen hsm10r1 = round(ssexm10r1*m10r1)
gen nhsm10r1 = m10r1 - hsm10r1
gen hsm11r1 = round(ssexm11r1*m11r1)
gen nhsm11r1 = m11r1 - hsm11r1
gen hsm12r1 = round(ssexm12r1*m12r1)
gen nhsm12r1 = m12r1 - hsm12r1

gen hsm9r2 = round(ssexm9r2*m9r2)
gen nhsm9r2 = m9r2 - hsm9r2
gen hsm10r2 = round(ssexm10r2*m10r2)
gen nhsm10r2 = m10r2 - hsm10r2
gen hsm11r2 = round(ssexm11r2*m11r2)
gen nhsm11r2 = m11r2 - hsm11r2
gen hsm12r2 = round(ssexm12r2*m12r2)
gen nhsm12r2 = m12r2 - hsm12r2

gen hsm9r3 = round(ssexm9r3*m9r3)
gen nhsm9r3 = m9r3 - hsm9r3
gen hsm10r3 = round(ssexm10r3*m10r3)
gen nhsm10r3 = m10r3 - hsm10r3
gen hsm11r3 = round(ssexm11r3*m11r3)
gen nhsm11r3 = m11r3 - hsm11r3
gen hsm12r3 = round(ssexm12r3*m12r3)
gen nhsm12r3 = m12r3 - hsm12r3
 

gen hsm9r4 = round(ssexm9r4*m9r4)
gen nhsm9r4 = m9r4 - hsm9r4
gen hsm10r4 = round(ssexm10r4*m10r4)
gen nhsm10r4 = m10r4 - hsm10r4
gen hsm11r4 = round(ssexm11r4*m11r4)
gen nhsm11r4 = m11r4 - hsm11r4
gen hsm12r4 = round(ssexm12r4*m12r4)
gen nhsm12r4 = m12r4 - hsm12r4

gen hsf9r1 = round(ssexf9r1*f9r1)
gen nhsf9r1 = f9r1 - hsf9r1
gen hsf10r1 = round(ssexf10r1*f10r1)
gen nhsf10r1 = f10r1 - hsf10r1
gen hsf11r1 = round(ssexf11r1*f11r1)
gen nhsf11r1 = f11r1 - hsf11r1
gen hsf12r1 = round(ssexf12r1*f12r1)
gen nhsf12r1 = f12r1 - hsf12r1

gen hsf9r2 = round(ssexf9r2*f9r2)
gen nhsf9r2 = f9r2 - hsf9r2
gen hsf10r2 = round(ssexf10r2*f10r2)
gen nhsf10r2 = f10r2 - hsf10r2
gen hsf11r2 = round(ssexf11r2*f11r2)
gen nhsf11r2 = f11r2 - hsf11r2
gen hsf12r2 = round(ssexf12r2*f12r2)
gen nhsf12r2 = f12r2 - hsf12r2

gen hsf9r3 = round(ssexf9r3*f9r3)
gen nhsf9r3 = f9r3 - hsf9r3
gen hsf10r3 = round(ssexf10r3*f10r3)
gen nhsf10r3 = f10r3 - hsf10r3
gen hsf11r3 = round(ssexf11r3*f11r3)
gen nhsf11r3 = f11r3 - hsf11r3
gen hsf12r3 = round(ssexf12r3*f12r3)
gen nhsf12r3 = f12r3 - hsf12r3
 

gen hsf9r4 = round(ssexf9r4*f9r4)
gen nhsf9r4 = f9r4 - hsf9r4
gen hsf10r4 = round(ssexf10r4*f10r4)
gen nhsf10r4 = f10r4 - hsf10r4
gen hsf11r4 = round(ssexf11r4*f11r4)
gen nhsf11r4 = f11r4 - hsf11r4
gen hsf12r4 = round(ssexf12r4*f12r4)
gen nhsf12r4 = f12r4 - hsf12r4


***************************
*GPA by priorsex dist.
***************************
egen sharesexmlow = mean(sexprior) if gpa_l==1&boys==1, by(sid)
egen ssexmlow = min(sharesexmlow), by(sid)
egen sharesexmmed = mean(sexprior) if gpa_m==1&boys==1, by(sid)
egen ssexmmed = min(sharesexmmed), by(sid)
egen sharesexmhi = mean(sexprior) if gpa_h==1&boys==1, by(sid)
egen ssexmhi = min(sharesexmhi), by(sid)

gen hsmlow = round(ssexmlow*m_gpa_low_t)
gen nhsmlow = m_gpa_low_t - hsmlow
gen hsmmed = round(ssexmmed*m_gpa_med_t)
gen nhsmmed = m_gpa_med_t - hsmmed
gen hsmhi = round(ssexmhi*m_gpa_hi_t)
gen nhsmhi = m_gpa_hi_t - hsmhi

egen sharesexflow = mean(sexprior) if gpa_l==1&boys==0, by(sid)
egen ssexflow = min(sharesexflow), by(sid)
egen sharesexfmed = mean(sexprior) if gpa_m==1&boys==0, by(sid)
egen ssexfmed = min(sharesexfmed), by(sid)
egen sharesexfhi = mean(sexprior) if gpa_h==1&boys==0, by(sid)
egen ssexfhi = min(sharesexfhi), by(sid)

gen hsflow = round(ssexmlow*f_gpa_low_t)
gen nhsflow = f_gpa_low_t - hsflow
gen hsfmed = round(ssexflow*f_gpa_med_t)
gen nhsfmed = f_gpa_med_t - hsfmed
gen hsfhi = round(ssexfhi*f_gpa_hi_t)
gen nhsfhi = f_gpa_hi_t - hsmhi

gen mlow = m_gpa_low_t
gen mmed = m_gpa_med_t
gen mhi = m_gpa_hi_t

gen flow = f_gpa_low_t
gen fmed = f_gpa_med_t
gen fhi = f_gpa_hi_t


***************************
*GPA_ME by priorsex dist.
***************************
egen sharesexmlow_me = mean(sexprior) if gpa_me_l==1&boys==1, by(sid)
egen ssexmlow_me = min(sharesexmlow_me), by(sid)
egen sharesexmmed_me = mean(sexprior) if gpa_me_m==1&boys==1, by(sid)
egen ssexmmed_me = min(sharesexmmed_me), by(sid)
egen sharesexmhi_me = mean(sexprior) if gpa_me_h==1&boys==1, by(sid)
egen ssexmhi_me = min(sharesexmhi_me), by(sid)

gen hsmlow_me = round(ssexmlow_me*m_gpa_low_t)
gen nhsmlow_me = m_gpa_ME_low_t - hsmlow_me
gen hsmmed_me = round(ssexmmed_me*m_gpa_med_t)
gen nhsmmed_me = m_gpa_ME_med_t - hsmmed_me
gen hsmhi_me = round(ssexmhi_me*m_gpa_hi_t)
gen nhsmhi_me = m_gpa_ME_hi_t - hsmhi_me

egen sharesexflow_me = mean(sexprior) if gpa_me_l==1&boys==0, by(sid)
egen ssexflow_me = min(sharesexflow_me), by(sid)
egen sharesexfmed_me = mean(sexprior) if gpa_me_m==1&boys==0, by(sid)
egen ssexfmed_me = min(sharesexfmed_me), by(sid)
egen sharesexfhi_me = mean(sexprior) if gpa_me_h==1&boys==0, by(sid)
egen ssexfhi_me = min(sharesexfhi_me), by(sid)

gen hsflow_me = round(ssexmlow_me*f_gpa_low_t)
gen nhsflow_me = f_gpa_ME_low_t - hsflow
gen hsfmed_me = round(ssexflow_me*f_gpa_med_t)
gen nhsfmed_me = f_gpa_ME_med_t - hsfmed_me
gen hsfhi_me = round(ssexfhi_me*f_gpa_hi_t)
gen nhsfhi_me = f_gpa_ME_hi_t - hsmhi_me

gen mlow_me = m_gpa_ME_low_t
gen mmed_me = m_gpa_ME_med_t
gen mhi_me = m_gpa_ME_hi_t

gen flow_me = f_gpa_ME_low_t
gen fmed_me = f_gpa_ME_med_t
gen fhi_me = f_gpa_ME_hi_t


by sid: gen mr1 =hsg9r1sm+hsg10r1sm+hsg11r1sm+hsg12r2sm 
by sid: gen mr2 =hsg9r2sm+hsg10r2sm+hsg11r2sm+hsg12r2sm 
by sid: gen mr3 =hsg9r3sm+hsg10r3sm+hsg11r3sm+hsg12r3sm  
by sid: gen mr4 =hsg9r4sm+hsg10r4sm+hsg11r4sm+hsg12r4sm
by sid: gen fr1 =hsg9r1sf+hsg10r1sf+hsg11r1sf+hsg12r2sf 
by sid: gen fr2 =hsg9r2sf+hsg10r2sf+hsg11r2sf+hsg12r2sf 
by sid: gen fr3 =hsg9r3sf+hsg10r3sf+hsg11r3sf+hsg12r3sf  
by sid: gen fr4 =hsg9r4sf+hsg10r4sf+hsg11r4sf+hsg12r4sf





*********************************************************
*Knowing Partner
*********************************************************

gen waysknown = (h1ri8a_1==1) + (h1ri8b_1==1) + (h1ri8c_1==1) + (h1ri8d_1==1) + (h1ri8e_1==1) + (h1ri8f_1==1) + (h1ri8g_1==1) if current1==1&h1ri8a_1<6 
replace waysknown = (h1ri8a_2==1) + (h1ri8b_2==1) + (h1ri8c_2==1) + (h1ri8d_2==1) + (h1ri8e_2==1) + (h1ri8f_2==1) + (h1ri8g_2==1) if current2==1&h1ri8a_2<6&waysknown==.
replace waysknown = (h1ri8a_3==1) + (h1ri8b_3==1) + (h1ri8c_3==1) + (h1ri8d_3==1) + (h1ri8e_3==1) + (h1ri8f_3==1) + (h1ri8g_3==1) if current3==1&h1ri8a_3<6&waysknown==.

replace waysknown = (h1rx8a_1==1) + (h1rx8b_1==1) + (h1rx8c_1==1) + (h1rx8d_1==1) + (h1rx8e_1==1) + (h1rx8f_1==1) + (h1rx8g_1==1) if current1nx==1&h1rx8a_1<6&waysknown==. 
replace waysknown = (h1rx8a_2==1) + (h1rx8b_2==1) + (h1rx8c_2==1) + (h1rx8d_2==1) + (h1rx8e_2==1) + (h1rx8f_2==1) + (h1rx8g_2==1) if current2nx==1&h1rx8a_2<6&waysknown==.
replace waysknown = (h1rx8a_3==1) + (h1rx8b_3==1) + (h1rx8c_3==1) + (h1rx8d_3==1) + (h1rx8e_3==1) + (h1rx8f_3==1) + (h1rx8g_3==1) if current3nx==1&h1rx8a_3<6&waysknown==. 

replace waysknown = (h1nr20a1==1) + (h1nr20b1==1) + (h1nr20c1==1) +(h1nr20d1==1) + (h1nr20e1==1) + (h1nr20f1==1) + (h1nr20g1==1) if current1nr==1&h1nr20a1<6&waysknown==. 
replace waysknown = (h1nr20a2==1) + (h1nr20b2==1) + (h1nr20c2==1) + (h1nr20d2==1) + (h1nr20e2==1) + (h1nr20f2==1) + (h1nr20f2==1) if current2nr==1&h1nr20a2<6&waysknown==.
replace waysknown = (h1nr20a3==1) + (h1nr20b3==1) + (h1nr20c3==1) + (h1nr20d3==1) + (h1nr20e3==1) + (h1nr20f3==1) + (h1nr20f3==1) if current3nr==1&h1nr20a3<6&waysknown==. 


gen noknown = (h1ri8h_1==1) if current1==1&h1ri8h_1<6 
replace noknown = (h1ri8h_2==1) if current2==1&h1ri8h_2<6&noknown==.
replace noknown = (h1ri8h_3==1)  if current3==1&h1ri8h_3<6&noknown==.

replace noknown = (h1rx8h_1==1)  if current1nx==1&h1rx8h_1<6&noknown==.
replace noknown = (h1rx8h_2==1)  if current2nx==1&h1rx8h_2<6&noknown==.
replace noknown = (h1rx8h_3==1)  if current3nx==1&h1rx8h_3<6&noknown==.
replace noknown = (h1nr20h1==1)  if current1nr==1&h1nr20h1<6&noknown==.
replace noknown = (h1nr20h2==1)  if current2nr==1&h1nr20h2<6&noknown==.
replace noknown = (h1nr20h3==1)  if current3nr==1&h1nr20h3<6&noknown==.

gen enggrade = h1ed11 if h1ed11 <5
gen mathgrade = h1ed12 if h1ed12 <5
gen histgrade = h1ed13 if h1ed13 <5
gen scigrade = h1ed14 if h1ed14 <5

gen curss = (current1==1)*(sameschool1==1) + (current2==1)*(sameschool2==1) + (current3==1)*(sameschool3==1) + (current1nr==1)*(sameschool1nr==1) + (current2nr==1)*(sameschool2nr==1) + (current3nr==1)*(sameschool3nr==1) +  (current1nx==1)*(sameschool1nx==1) + (current2nx==1)*(sameschool2nx==1) + (current3nx==1)*(sameschool3nx==1)    

replace gr = (f9+f10+f11+f12)/(f9+f10+f11+f12+m9+m10+m11+m12)

gen matched = (sexcurallss==1|relcurallss==1)
 


*save  datasetlessinfo.dta , replace
