
clear
%matlabpool close
 matlabpool open

for numiter = 1:50
    if numiter > 1
        clearvars -except b_numiter rho A btrue output eflag hess beta0 b_out* b_est* btrue N Nd numiter
    end
    rng(234591117+numiter)
    N=5000;
    Nd=75;
    
    
    district = unidrnd(Nd,N,1);
    euler = 0.57721;
    iage = unidrnd(2,N,1);
    ied = unidrnd(2,N,1);
    type =ied +2.*(iage-1);
    
    ntypes = max(type);
    nptypes = ntypes;
    
    rho  = -1.65;
    A=.40;
    age = 1+(rand(N,1)>.5);
    tv_m = 0;
    tv_f = 0;
    T=1;
    nterms=2;
    nm = ntypes*nterms;
    beta=.95;
    norm=ntypes+1;
    bm_near = -2.25;
    bf_near = 2;
    bf_page = 3.25;
    bm_page = -2;
    bf_ped = -1.30;
    bm_ped = 4.25;
    sig =  2;
    c=1./sig;
    term = [ones(ntypes,nptypes) zeros(ntypes,nptypes) ];%(rand(N,1)>.5);
    
    own_type_mat = [1*ones(1,nm); 2*ones(1,nm); 3*ones(1,nm); 4*ones(1,nm)];
    
    ED = [zeros(1,nm) ; ones(1,nm) ; zeros(1,nm); ones(1,nm)];
    AGE = [0*ones(2,nm) ; 1*ones(2,nm)];
    
    PED = [zeros(ntypes,1) ones(ntypes,1)  zeros(ntypes,1)  ones(ntypes,1) zeros(ntypes,1) ones(ntypes,1)  zeros(ntypes,1)  ones(ntypes,1)];
    PAGE = [0*ones(ntypes,2)   1*ones(ntypes,2)  0*ones(ntypes,2)   1*ones(ntypes,2)];
    
    female = (rand(N,1)>.5);
    
    mm_nsm = unidrnd(1000,ntypes,Nd)+1000;
    mm_nsw = unidrnd(1000,ntypes,Nd)+1000;
    
    out_shifter=mm_nsw./mm_nsm;
    b_outed = -.5;
    b_outage = -.25;
    b_outshifter = -1;
    b_outed_f = .5;
    b_outage_f = .25;
    b_outshifter_f = -1;
    
    
    for k =1:Nd
        for i=1:ntypes
            outu = b_outed*ED(i,1)*out_shifter(i,k)  + b_outage*AGE(i,1)*out_shifter(i,k)  + b_outshifter*out_shifter(i,k)   ;
            Psearch_out(i,k) = exp(outu)./(1+exp(outu));
            outu = b_outed_f*ED(i,1)*out_shifter(i,k)  + b_outage_f*AGE(i,1)*out_shifter(i,k)  + b_outshifter_f*out_shifter(i,k);
            Psearch_out_f(i,k) = exp(outu)./(1+exp(outu));
            
            outu = b_outed*ED(i,1) + b_outage*AGE(i,1) + b_outshifter*out_shifter(i,k)  ;
            Psearch_out_approx(i,k) = exp(outu)./(1+exp(outu));
            outu = b_outed_f*ED(i,1)  + b_outage_f*AGE(i,1) + b_outshifter_f*out_shifter(i,k) ;
            Psearch_out_approx_f(i,k) = exp(outu)./(1+exp(outu));
        end
    end
 
    mm_nsm = mm_nsm.*(1-Psearch_out);
    mm_nsw = mm_nsw.*(1-Psearch_out_f);
    
    mm_nsm_approx = mm_nsm;%.*(1-Psearch_out_approx);
    mm_nsw_approx = mm_nsw;%.*(1-Psearch_out_approx_f);
   
    rng(23459117+numiter)
    draw=rand(N,1);
    for i=1:N
        for k = 1:Nd
            s_in(i,1) =  1-((draw(i,1)<Psearch_out_f(type(i,1),k)).*(female(i,1)==1) +  (draw(i,1)<Psearch_out(type(i,1),k)).*(female(i,1)==0));
        end
    end
    
    
    
    Pft_new_par=(1/nm)*ones(ntypes,nm,Nd,T);
    Pmt_new_par=(1/nm)*ones(ntypes,nm,Nd,T);
    Pmatchf_new_par=.25*ones(ntypes,nm,Nd,T);
    Pmatchm_new_par=.25*ones(ntypes,nm,Nd,T);
 
    for k=1:Nd
        Uftemp = zeros(ntypes,nm,T);
        Umtemp = zeros(ntypes,nm,T);
        Ptempf_dyn = zeros(ntypes,nm,T);
        Ptempm_dyn = zeros(ntypes,nm,T);
        Pmatchf_new=.25*ones(ntypes,nm,T);
        Pmatchm_new=.25*ones(ntypes,nm,T);
        
        Umatf =  bf_near*term + bf_page.*(PAGE ) + bf_ped.*PED;
        Uf(:,:,1) = c*Umatf ;
 
        
        Umatm =  bm_near*term + bm_page.*(PAGE ) + bm_ped.*PED;
        Um(:,:,1) = c*Umatm ;
 
        Pft_new(:,:,1)=exp((Uf ))./(sum(exp((Uf  ) ),2)*ones(1,nm));
        Pmt_new(:,:,1)=exp((Um ))./(sum(exp((Um  ) ),2)*ones(1,nm));
        
        counter=0;
        tmp_dyn =1;
        while tmp_dyn >.0001 %this loop sets an initial vector of Pmatch (Pmatch0) across time
            Ptempfo_dyn=squeeze(Pmatchf_new(:,:,:));
            Ptempmo_dyn=squeeze(Pmatchm_new(:,:,:));
            %initial guess at the per=period probability of matching
            t=T;
            while t>0
                Ptempf=squeeze(Pmatchf_new(:,:,t));%.250*ones(size(squeeze(Pmatchf_new(:,:,k,t))));%
                Ptempm=squeeze(Pmatchm_new(:,:,t));%.250*ones(size(squeeze(Pmatchm_new(:,:,k,t))));%
                
                Nft   = [mm_nsw(:,k)]*ones(1,nm);
                Nmt   = [mm_nsm(:,k)]*ones(1,nm);
                
                Uft= c.*(Umatf + log(Ptempf./(Ptempf(:,norm)*ones(1,nm)))) ;% + (1-Ptempf).*CV_f ;
                Umt= c.*(Umatm + log(Ptempm./(Ptempm(:,norm)*ones(1,nm))))  ;%+ (1-Ptempm).*CV_m ;
                Pft=exp(Uft)./(sum(exp(Uft),2)*ones(1,nm));
                Pmt=exp(Umt)./(sum(exp(Umt),2)*ones(1,nm));
                Sft= Nft.*Pft ;
                Smt= Nmt.*Pmt;
                
                zero_m = (Smt==0);
                zero_f = (Sft==0);
                
                Ptempf= (A.*(.5+.5*([Smt(1:ntypes,1:ntypes)' Smt(1:ntypes,ntypes+1:2*ntypes)']./(Sft+(Sft==0))).^rho).^(1/rho)).*(zero_f==0) ;
                Ptempm= (A.*(.5+.5*([Sft(1:ntypes,1:ntypes)' Sft(1:ntypes,ntypes+1:2*ntypes)']./(Smt+(Smt==0))).^rho).^(1/rho)).*(zero_m==0);
                Ptempf_leon =  (min([Smt(1:ntypes,1:ntypes)' Smt(1:ntypes,ntypes+1:2*ntypes)'],(Sft))./(Sft+(Sft==0))).*(zero_f==0);
                Ptempm_leon =  (min([Sft(1:ntypes,1:ntypes)' Sft(1:ntypes,ntypes+1:2*ntypes)'],(Smt))./(Smt+(Smt==0))).*(zero_m==0);
                one_mat_f = (Ptempf>=1);
                one_mat_m = (Ptempm>=1);
                Ptempf(:,1:ntypes) = Ptempf(:,1:ntypes).*(one_mat_m(:,1:ntypes)'==0) + Ptempf_leon(:,1:ntypes).*(one_mat_m(:,1:ntypes)'==1);
                Ptempm(:,1:ntypes) = Ptempm(:,1:ntypes).*(one_mat_f(:,1:ntypes)'==0) + Ptempm_leon(:,1:ntypes).*(one_mat_f(:,1:ntypes)'==1);
                Ptempf(:,ntypes+1:2*ntypes) = Ptempf(:,ntypes+1:2*ntypes).*(one_mat_m(:,ntypes+1:2*ntypes)'==0) + Ptempf_leon(:,ntypes+1:2*ntypes).*(one_mat_m(:,ntypes+1:2*ntypes)'==1);
                Ptempm(:,ntypes+1:2*ntypes) = Ptempm(:,ntypes+1:2*ntypes).*(one_mat_f(:,ntypes+1:2*ntypes)'==0) + Ptempm_leon(:,ntypes+1:2*ntypes).*(one_mat_f(:,ntypes+1:2*ntypes)'==1);
                Ptempf =max(min(.99999,Ptempf),.00001);
                Ptempm =max(min(.99999,Ptempm),.00001);
                Ptempf_dyn(:,:,t)= Ptempf ;
                Ptempm_dyn(:,:,t)= Ptempm ;
                Umtemp(:,:,t)=  Umt;
                Uftemp(:,:,t)=  Uft;
                t=t-1;
            end
            Pmatchf_new =Ptempf_dyn ;
            Pmatchm_new =Ptempm_dyn ;
            Uf =Uftemp ;
            Um =Umtemp ;
            Pft_new(:,:,1)=exp((Uf(:,:,1) ) )./(sum(exp((Uf(:,:,1) ) ),2)*ones(1,nm));
            Pmt_new(:,:,1)=exp((Um(:,:,1) ) )./(sum(exp((Um(:,:,1) ) ),2)*ones(1,nm));
            tmp_dyn = max(max(max([abs(Ptempfo_dyn-squeeze(Pmatchf_new(:,:,:))) abs(Ptempmo_dyn-squeeze(Pmatchm_new(:,:,:)))])));
            counter=counter+1;
        end
        
        Pft_new_par(:,:,k,:)=Pft_new;
        Pmt_new_par(:,:,k,:)=Pmt_new;
        
        Pmatchf_new_par(:,:,k,:)= Pmatchf_new(:,:,:);
        Pmatchm_new_par(:,:,k,:)= Pmatchm_new(:,:,:);
        
    end
    
    
    
    index_search = rand(N,T);
    index_match = rand(N,T);
    
    for i = 1:N
        k=district(i,1);
        if female(i,1) == 1 && s_in(i,1)==1
            psearch1 = Pft_new_par(type(i),:,k,1);
            y_search1(i,1) = 1*(index_search(i,1)<psearch1(1)) ...
                + 2*(index_search(i,1)>psearch1(1)).*(index_search(i,1)<sum(psearch1(1:2)))...
                + 3*(index_search(i,1)>sum(psearch1(1:2))).*(index_search(i,1)<sum(psearch1(1:3)))...
                + 4*(index_search(i,1)>sum(psearch1(1:3))).*(index_search(i,1)<sum(psearch1(1:4)))...
                + 5*(index_search(i,1)>sum(psearch1(1:4))).*(index_search(i,1)<sum(psearch1(1:5))) ...
                + 6*(index_search(i,1)>sum(psearch1(1:5))).*(index_search(i,1)<sum(psearch1(1:6))) ...
                + 7*(index_search(i,1)>sum(psearch1(1:6))).*(index_search(i,1)<sum(psearch1(1:7))) ...
                + 8*(index_search(i,1)>sum(psearch1(1:7))) ;
            pmatch1 = Pmatchf_new_par(type(i),:,k,1);
            y_match1(i,1) =  y_search1(i,1).*(index_match(i,1)<pmatch1(y_search1(i,1)));
         end
        
        if female(i,1) == 0 && s_in(i,1)==1
            psearch1 = Pmt_new_par(type(i),:,k,1); 
            y_search1(i,1) = 1*(index_search(i,1)<psearch1(1)) ...
                + 2*(index_search(i,1)>psearch1(1)).*(index_search(i,1)<sum(psearch1(1:2)))...
                + 3*(index_search(i,1)>sum(psearch1(1:2))).*(index_search(i,1)<sum(psearch1(1:3)))...
                + 4*(index_search(i,1)>sum(psearch1(1:3))).*(index_search(i,1)<sum(psearch1(1:4)))...
                + 5*(index_search(i,1)>sum(psearch1(1:4))).*(index_search(i,1)<sum(psearch1(1:5))) ...
                + 6*(index_search(i,1)>sum(psearch1(1:5))).*(index_search(i,1)<sum(psearch1(1:6))) ...
                + 7*(index_search(i,1)>sum(psearch1(1:6))).*(index_search(i,1)<sum(psearch1(1:7))) ...
                + 8*(index_search(i,1)>sum(psearch1(1:7))) ;
            pmatch1 = Pmatchm_new_par(type(i),:,k,1);
            y_match1(i,1) =  y_search1(i,1).*(index_match(i,1)<pmatch1(y_search1(i,1)));
        end
        
    end
    Y = [y_match1 ];
    Ysearch = [y_search1];
    
    for k = 1:nm
        for t = 1:T
            YY(:,k,t) =  (Y(:,t)==k);
            YYs(:,k,t) =  (Ysearch(:,t)==k);
        end
    end

    %Likelihood estimation of bf_near, bm_near, rho, A, and beta if possible.
    %Observables are Y, type, aggregate distributions of men and women tomorrow and today.
    btrue = [rho A c  bm_near bf_near bf_page bm_page bf_ped bm_ped  ]';
    beta0 = [log(-rho); log((1-A)/A); log((1-c)/c); btrue(4:9)]*1;% btrue(5:10)*1.5;]
    opt=optimset('TolFun',1e-16,'TolX',1e-16,'MaxFunEvals',1e6,'MaxIter',1e6);
    [beta1,fval,e,o,g,h] =  fminunc('like_static_4types_QE_RR',beta0,[opt],YY(s_in==1,:),type(s_in==1,:),mm_nsw_approx,mm_nsm_approx,district(s_in==1,:),term,female(s_in==1,:),YYs(s_in==1,:),ED,PED,AGE,PAGE)
  
    b_est = [-exp(beta1(1)) exp(beta1(2))./(1+exp(beta1(2))) exp(beta1(3))./(1+exp(beta1(3))) beta1(4:9)']' ;
    b_est0 = [-exp(beta0(1)) exp(beta0(2))./(1+exp(beta0(2))) exp(beta0(3))./(1+exp(beta0(3))) beta0(4:9)']' ;
     
    [b_est0  b_est btrue]
    b_numiter(:,numiter) = b_est;
    output(numiter)      = o;
    eflag(numiter)       = e;
    hess(:,:,numiter)    = h;
    save mc_4t_QE_RR_fullinfo_nomissp.mat b_numiter rho A btrue output eflag hess beta0 b_out* b_est* btrue N Nd numiter
    
end

matlabpool close

 


